Statistics
| Branch: | Tag: | Revision:

root / Makefile.am @ b8203e1e

History | View | Annotate | Download (41.7 kB)

1 e8230860 Michael Hanselmann
# Ganeti makefile
2 e8230860 Michael Hanselmann
# - Indent with tabs only.
3 e8230860 Michael Hanselmann
# - Keep files sorted; one line per file.
4 e8230860 Michael Hanselmann
# - Directories in lib/ must have their own *dir variable (see hypervisor).
5 e8230860 Michael Hanselmann
# - All directories must be listed DIRS.
6 0a7bed64 Michael Hanselmann
# - Use autogen.sh to generate Makefile.in and configure script.
7 e8230860 Michael Hanselmann
8 e8230860 Michael Hanselmann
# Automake doesn't export these variables before version 1.10.
9 e8230860 Michael Hanselmann
abs_top_builddir = @abs_top_builddir@
10 e8230860 Michael Hanselmann
abs_top_srcdir = @abs_top_srcdir@
11 e8230860 Michael Hanselmann
12 08366664 Michael Hanselmann
# Helper values for calling builtin functions
13 08366664 Michael Hanselmann
empty :=
14 08366664 Michael Hanselmann
space := $(empty) $(empty)
15 08366664 Michael Hanselmann
comma := ,
16 08366664 Michael Hanselmann
17 a01dd3c6 Iustin Pop
# Use bash in order to be able to use pipefail
18 a01dd3c6 Iustin Pop
SHELL=/bin/bash
19 a01dd3c6 Iustin Pop
20 6e06b36c Iustin Pop
ACLOCAL_AMFLAGS = -I autotools
21 4f3d5b76 Michael Hanselmann
BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
22 b959138f Michael Hanselmann
RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
23 eed5c5df Michael Hanselmann
CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
24 5d3c30df Michael Hanselmann
CHECK_HEADER = $(top_srcdir)/autotools/check-header
25 c55cc346 Iustin Pop
CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
26 73d0e218 Iustin Pop
CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
27 96602be4 Michael Hanselmann
CHECK_VERSION = $(top_srcdir)/autotools/check-version
28 7385c51d Michael Hanselmann
CHECK_NEWS = $(top_srcdir)/autotools/check-news
29 f6cbcc06 Michael Hanselmann
CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
30 95eb4188 Michael Hanselmann
DOCPP = $(top_srcdir)/autotools/docpp
31 e8230860 Michael Hanselmann
REPLACE_VARS_SED = autotools/replace_vars.sed
32 d99d1e36 Iustin Pop
CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
33 d5a2a550 Michael Hanselmann
BUILD_RPC = $(top_srcdir)/autotools/build-rpc
34 e8230860 Michael Hanselmann
35 22c5390d Iustin Pop
# Note: these are automake-specific variables, and must be named after
36 22c5390d Iustin Pop
# the directory + 'dir' suffix
37 2d48a3a2 Michael Hanselmann
clientdir = $(pkgpythondir)/client
38 e8230860 Michael Hanselmann
hypervisordir = $(pkgpythondir)/hypervisor
39 ff9efc03 Michael Hanselmann
httpdir = $(pkgpythondir)/http
40 dc101ecc Michael Hanselmann
masterddir = $(pkgpythondir)/masterd
41 12426ae1 Guido Trotter
confddir = $(pkgpythondir)/confd
42 8c229cc7 Oleksiy Mishchenko
rapidir = $(pkgpythondir)/rapi
43 899c4d2c Michael Hanselmann
serverdir = $(pkgpythondir)/server
44 9f4bb951 Michael Hanselmann
watcherdir = $(pkgpythondir)/watcher
45 bb44b1ae Michael Hanselmann
impexpddir = $(pkgpythondir)/impexpd
46 c047a981 Michael Hanselmann
utilsdir = $(pkgpythondir)/utils
47 e8230860 Michael Hanselmann
toolsdir = $(pkglibdir)/tools
48 7617fd6b Iustin Pop
iallocatorsdir = $(pkglibdir)/iallocators
49 0d2bf835 René Nussbaumer
pytoolsdir = $(pkgpythondir)/tools
50 e8230860 Michael Hanselmann
docdir = $(datadir)/doc/$(PACKAGE)
51 b8fe7ca6 Iustin Pop
myexeclibdir = $(pkglibdir)
52 e8230860 Michael Hanselmann
53 a4f12da4 Michael Hanselmann
# Delete output file if an error occurred while building it
54 a4f12da4 Michael Hanselmann
.DELETE_ON_ERROR:
55 a4f12da4 Michael Hanselmann
56 d5506465 Iustin Pop
HTOOLS_DIRS = \
57 d5506465 Iustin Pop
	htools \
58 d5506465 Iustin Pop
	htools/Ganeti \
59 358a0a8f Iustin Pop
	htools/Ganeti/Confd \
60 458a286a Iustin Pop
	htools/Ganeti/HTools \
61 458a286a Iustin Pop
	htools/Ganeti/HTools/Program
62 d5506465 Iustin Pop
63 e8230860 Michael Hanselmann
DIRS = \
64 e8230860 Michael Hanselmann
	autotools \
65 e8230860 Michael Hanselmann
	daemons \
66 e8230860 Michael Hanselmann
	devel \
67 e8230860 Michael Hanselmann
	doc \
68 e8230860 Michael Hanselmann
	doc/examples \
69 d6d9ce45 Guido Trotter
	doc/examples/hooks \
70 c51580b3 Guido Trotter
	doc/examples/gnt-debug \
71 d5506465 Iustin Pop
	$(HTOOLS_DIRS) \
72 e8230860 Michael Hanselmann
	lib \
73 2d48a3a2 Michael Hanselmann
	lib/client \
74 f9897b6d Michael Hanselmann
	lib/build \
75 2f16ea8f Michael Hanselmann
	lib/confd \
76 ff9efc03 Michael Hanselmann
	lib/http \
77 e8230860 Michael Hanselmann
	lib/hypervisor \
78 bb44b1ae Michael Hanselmann
	lib/impexpd \
79 dc101ecc Michael Hanselmann
	lib/masterd \
80 8c229cc7 Oleksiy Mishchenko
	lib/rapi \
81 899c4d2c Michael Hanselmann
	lib/server \
82 0d2bf835 René Nussbaumer
	lib/tools \
83 c047a981 Michael Hanselmann
	lib/utils \
84 9f4bb951 Michael Hanselmann
	lib/watcher \
85 e8230860 Michael Hanselmann
	man \
86 e8230860 Michael Hanselmann
	qa \
87 e8230860 Michael Hanselmann
	test \
88 e8230860 Michael Hanselmann
	test/data \
89 6bbd76d2 Iustin Pop
	test/data/htools \
90 91e5a351 Iustin Pop
	test/data/htools/rapi \
91 1e6fab60 Agata Murawska
	test/data/ovfdata \
92 d92518d3 Agata Murawska
	test/data/ovfdata/other \
93 e8230860 Michael Hanselmann
	tools
94 e8230860 Michael Hanselmann
95 2750b299 Michael Hanselmann
BUILDTIME_DIR_AUTOCREATE = \
96 c964d962 Michael Hanselmann
	scripts \
97 22c5390d Iustin Pop
	$(APIDOC_DIR) \
98 22c5390d Iustin Pop
	$(APIDOC_PY_DIR) \
99 22c5390d Iustin Pop
	$(APIDOC_HS_DIR) \
100 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti \
101 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/Confd \
102 358a0a8f Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools \
103 458a286a Iustin Pop
	$(APIDOC_HS_DIR)/Ganeti/HTools/Program \
104 22c5390d Iustin Pop
	$(COVERAGE_DIR) \
105 22c5390d Iustin Pop
	$(COVERAGE_PY_DIR) \
106 22c5390d Iustin Pop
	$(COVERAGE_HS_DIR) \
107 b91e9518 Iustin Pop
	.hpc
108 2750b299 Michael Hanselmann
109 2750b299 Michael Hanselmann
BUILDTIME_DIRS = \
110 2750b299 Michael Hanselmann
	$(BUILDTIME_DIR_AUTOCREATE) \
111 6b997854 Michael Hanselmann
	doc/html
112 6b997854 Michael Hanselmann
113 6b997854 Michael Hanselmann
DIRCHECK_EXCLUDE = \
114 6b997854 Michael Hanselmann
	$(BUILDTIME_DIRS) \
115 6b997854 Michael Hanselmann
	ganeti-[0-9]*.[0-9]*.[0-9]* \
116 6b997854 Michael Hanselmann
	doc/html/_*
117 6b997854 Michael Hanselmann
118 2750b299 Michael Hanselmann
all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
119 c964d962 Michael Hanselmann
120 22c5390d Iustin Pop
# some helper vars
121 22c5390d Iustin Pop
COVERAGE_DIR = doc/coverage
122 22c5390d Iustin Pop
COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
123 22c5390d Iustin Pop
COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
124 22c5390d Iustin Pop
APIDOC_DIR = doc/api
125 22c5390d Iustin Pop
APIDOC_PY_DIR = $(APIDOC_DIR)/py
126 22c5390d Iustin Pop
APIDOC_HS_DIR = $(APIDOC_DIR)/hs
127 22c5390d Iustin Pop
128 2ab2b9f5 Iustin Pop
MAINTAINERCLEANFILES = \
129 d17e74b4 Iustin Pop
	$(docpng) \
130 b76aac08 Michael Hanselmann
	$(maninput) \
131 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
132 84a12e40 Iustin Pop
	doc/news.rst \
133 7a03d293 Michael Hanselmann
	doc/upgrade.rst \
134 84a12e40 Iustin Pop
	vcs-version
135 2ab2b9f5 Iustin Pop
136 d17e74b4 Iustin Pop
maintainer-clean-local:
137 6b997854 Michael Hanselmann
	rm -rf $(BUILDTIME_DIRS)
138 d17e74b4 Iustin Pop
139 e8230860 Michael Hanselmann
CLEANFILES = \
140 2f16ea8f Michael Hanselmann
	$(addsuffix /*.py[co],$(DIRS)) \
141 d5506465 Iustin Pop
	$(addsuffix /*.hi,$(HTOOLS_DIRS)) \
142 d5506465 Iustin Pop
	$(addsuffix /*.o,$(HTOOLS_DIRS)) \
143 c964d962 Michael Hanselmann
	$(all_dirfiles) \
144 2d48a3a2 Michael Hanselmann
	$(PYTHON_BOOTSTRAP) \
145 f774bd03 Michael Hanselmann
	epydoc.conf \
146 e8230860 Michael Hanselmann
	autotools/replace_vars.sed \
147 f154a7a3 Michael Hanselmann
	daemons/daemon-util \
148 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner \
149 e8230860 Michael Hanselmann
	devel/upload \
150 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
151 f72f8622 Iustin Pop
	doc/examples/bash_completion \
152 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py \
153 2ab2b9f5 Iustin Pop
	$(man_MANS) \
154 2ab2b9f5 Iustin Pop
	$(manhtml) \
155 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
156 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
157 d6159933 Iustin Pop
	$(nodist_pkgpython_PYTHON) \
158 c3f67183 Iustin Pop
	$(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
159 3096524e Iustin Pop
	$(HS_BUILT_TEST_HELPERS) \
160 191ff68c Iustin Pop
	.hpc/*.mix htools/*.tix \
161 191ff68c Iustin Pop
	doc/hs-lint.html
162 e8230860 Michael Hanselmann
163 c964d962 Michael Hanselmann
# BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
164 c964d962 Michael Hanselmann
# it'll cause the target to rebuild every time.
165 dc7d2c49 Michael Hanselmann
BUILT_SOURCES = \
166 96a7481d Michael Hanselmann
  $(built_base_sources) \
167 96a7481d Michael Hanselmann
	$(BUILT_PYTHON_SOURCES) \
168 96a7481d Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
169 96a7481d Michael Hanselmann
170 96a7481d Michael Hanselmann
built_base_sources = \
171 dc7d2c49 Michael Hanselmann
	ganeti \
172 dd1dfd9a Michael Hanselmann
	stamp-srclinks \
173 96a7481d Michael Hanselmann
	$(all_dirfiles)
174 2d1f248e Michael Hanselmann
175 96a7481d Michael Hanselmann
built_python_base_sources = \
176 13aeae6a Iustin Pop
	lib/_autoconf.py \
177 96a7481d Michael Hanselmann
	lib/_vcsversion.py
178 96a7481d Michael Hanselmann
179 96a7481d Michael Hanselmann
BUILT_PYTHON_SOURCES = \
180 96a7481d Michael Hanselmann
	$(built_python_base_sources) \
181 d5a2a550 Michael Hanselmann
	lib/_generated_rpc.py
182 e8230860 Michael Hanselmann
183 96a7481d Michael Hanselmann
# Generating the RPC wrappers depends on many things, so make sure it's built at
184 96a7481d Michael Hanselmann
# the end of the built sources
185 96a7481d Michael Hanselmann
lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
186 96a7481d Michael Hanselmann
187 656a7fdf Iustin Pop
# these are all built from the underlying %.in sources
188 656a7fdf Iustin Pop
BUILT_EXAMPLES = \
189 656a7fdf Iustin Pop
	doc/examples/ganeti-kvm-poweroff.initd \
190 656a7fdf Iustin Pop
	doc/examples/ganeti.cron \
191 656a7fdf Iustin Pop
	doc/examples/ganeti.initd \
192 656a7fdf Iustin Pop
	doc/examples/gnt-config-backup \
193 656a7fdf Iustin Pop
	doc/examples/hooks/ipsec
194 656a7fdf Iustin Pop
195 08366664 Michael Hanselmann
nodist_pkgpython_PYTHON = \
196 08366664 Michael Hanselmann
	$(BUILT_PYTHON_SOURCES)
197 08366664 Michael Hanselmann
198 f9897b6d Michael Hanselmann
noinst_PYTHON = \
199 5f43f393 Michael Hanselmann
	lib/build/__init__.py \
200 7142485a Iustin Pop
	lib/build/sphinx_ext.py \
201 7142485a Iustin Pop
	lib/build/shell_example_lexer.py
202 f9897b6d Michael Hanselmann
203 e8230860 Michael Hanselmann
pkgpython_PYTHON = \
204 e8230860 Michael Hanselmann
	lib/__init__.py \
205 a8a76bc2 Guido Trotter
	lib/asyncnotifier.py \
206 e8230860 Michael Hanselmann
	lib/backend.py \
207 e8230860 Michael Hanselmann
	lib/bdev.py \
208 e8230860 Michael Hanselmann
	lib/bootstrap.py \
209 e8230860 Michael Hanselmann
	lib/cli.py \
210 e8230860 Michael Hanselmann
	lib/cmdlib.py \
211 cea881e5 Michael Hanselmann
	lib/compat.py \
212 e8230860 Michael Hanselmann
	lib/config.py \
213 e8230860 Michael Hanselmann
	lib/constants.py \
214 821d9e43 Michael Hanselmann
	lib/daemon.py \
215 e8230860 Michael Hanselmann
	lib/errors.py \
216 62e0e880 Iustin Pop
	lib/ht.py \
217 e8230860 Michael Hanselmann
	lib/jqueue.py \
218 8b537bb0 Michael Hanselmann
	lib/jstore.py \
219 e8230860 Michael Hanselmann
	lib/locking.py \
220 e8230860 Michael Hanselmann
	lib/luxi.py \
221 e8230860 Michael Hanselmann
	lib/mcpu.py \
222 a744b676 Manuel Franceschini
	lib/netutils.py \
223 e8230860 Michael Hanselmann
	lib/objects.py \
224 e8230860 Michael Hanselmann
	lib/opcodes.py \
225 ced78a66 Agata Murawska
	lib/ovf.py \
226 a123dc19 Michael Hanselmann
	lib/qlang.py \
227 4ca96421 Michael Hanselmann
	lib/query.py \
228 e8230860 Michael Hanselmann
	lib/rpc.py \
229 6648cb36 Michael Hanselmann
	lib/rpc_defs.py \
230 f12e1736 René Nussbaumer
	lib/runtime.py \
231 e8230860 Michael Hanselmann
	lib/serializer.py \
232 e8230860 Michael Hanselmann
	lib/ssconf.py \
233 e8230860 Michael Hanselmann
	lib/ssh.py \
234 ac2d0fe4 Michael Hanselmann
	lib/storage.py \
235 1338f2b4 Balazs Lecz
	lib/uidpool.py \
236 76094e37 Michael Hanselmann
	lib/workerpool.py
237 e8230860 Michael Hanselmann
238 2d48a3a2 Michael Hanselmann
client_PYTHON = \
239 c2855a12 Michael Hanselmann
	lib/client/__init__.py \
240 02266fe0 Michael Hanselmann
	lib/client/gnt_backup.py \
241 7b3e7d41 Michael Hanselmann
	lib/client/gnt_cluster.py \
242 6d50f5f9 Michael Hanselmann
	lib/client/gnt_debug.py \
243 667dbd6b Adeodato Simo
	lib/client/gnt_group.py \
244 e792102d Michael Hanselmann
	lib/client/gnt_instance.py \
245 a09b9e3d Michael Hanselmann
	lib/client/gnt_job.py \
246 37494fa4 Michael Hanselmann
	lib/client/gnt_node.py \
247 6d50f5f9 Michael Hanselmann
	lib/client/gnt_os.py
248 2d48a3a2 Michael Hanselmann
249 e8230860 Michael Hanselmann
hypervisor_PYTHON = \
250 e8230860 Michael Hanselmann
	lib/hypervisor/__init__.py \
251 e8230860 Michael Hanselmann
	lib/hypervisor/hv_base.py \
252 48297fa2 Iustin Pop
	lib/hypervisor/hv_chroot.py \
253 e8230860 Michael Hanselmann
	lib/hypervisor/hv_fake.py \
254 eb58f9b1 Guido Trotter
	lib/hypervisor/hv_kvm.py \
255 4b5e40a5 Iustin Pop
	lib/hypervisor/hv_lxc.py \
256 e8230860 Michael Hanselmann
	lib/hypervisor/hv_xen.py
257 e8230860 Michael Hanselmann
258 8c229cc7 Oleksiy Mishchenko
rapi_PYTHON = \
259 8c229cc7 Oleksiy Mishchenko
	lib/rapi/__init__.py \
260 10b207d4 Oleksiy Mishchenko
	lib/rapi/baserlib.py \
261 95ab4de9 David Knowles
	lib/rapi/client.py \
262 20b509de Michael Hanselmann
	lib/rapi/client_utils.py \
263 10b207d4 Oleksiy Mishchenko
	lib/rapi/connector.py \
264 a85f23fa Michael Hanselmann
	lib/rapi/rlib2.py \
265 a85f23fa Michael Hanselmann
	lib/rapi/testutils.py
266 8c229cc7 Oleksiy Mishchenko
267 ff9efc03 Michael Hanselmann
http_PYTHON = \
268 02cab3e7 Michael Hanselmann
	lib/http/__init__.py \
269 be500c29 Michael Hanselmann
	lib/http/auth.py \
270 02cab3e7 Michael Hanselmann
	lib/http/client.py \
271 02cab3e7 Michael Hanselmann
	lib/http/server.py
272 ff9efc03 Michael Hanselmann
273 12426ae1 Guido Trotter
confd_PYTHON = \
274 71f27d19 Guido Trotter
	lib/confd/__init__.py \
275 e4ccf6cd Guido Trotter
	lib/confd/client.py \
276 2f16ea8f Michael Hanselmann
	lib/confd/querylib.py \
277 2f16ea8f Michael Hanselmann
	lib/confd/server.py
278 8c229cc7 Oleksiy Mishchenko
279 dc101ecc Michael Hanselmann
masterd_PYTHON = \
280 033a1d00 Michael Hanselmann
	lib/masterd/__init__.py \
281 033a1d00 Michael Hanselmann
	lib/masterd/instance.py
282 dc101ecc Michael Hanselmann
283 bb44b1ae Michael Hanselmann
impexpd_PYTHON = \
284 bb44b1ae Michael Hanselmann
	lib/impexpd/__init__.py
285 bb44b1ae Michael Hanselmann
286 9f4bb951 Michael Hanselmann
watcher_PYTHON = \
287 9ca87fb3 Michael Hanselmann
	lib/watcher/__init__.py \
288 adf6301e Michael Hanselmann
	lib/watcher/nodemaint.py \
289 adf6301e Michael Hanselmann
	lib/watcher/state.py
290 9f4bb951 Michael Hanselmann
291 899c4d2c Michael Hanselmann
server_PYTHON = \
292 29d91329 Michael Hanselmann
	lib/server/__init__.py \
293 5c9c0e0e Michael Hanselmann
	lib/server/confd.py \
294 5119f2ec Michael Hanselmann
	lib/server/masterd.py \
295 d9c82a4e Michael Hanselmann
	lib/server/noded.py \
296 d9c82a4e Michael Hanselmann
	lib/server/rapi.py
297 899c4d2c Michael Hanselmann
298 0d2bf835 René Nussbaumer
pytools_PYTHON = \
299 0d2bf835 René Nussbaumer
	lib/tools/__init__.py \
300 0d2bf835 René Nussbaumer
	lib/tools/ensure_dirs.py
301 0d2bf835 René Nussbaumer
302 c047a981 Michael Hanselmann
utils_PYTHON = \
303 4fd029cf Michael Hanselmann
	lib/utils/__init__.py \
304 79d22269 Michael Hanselmann
	lib/utils/algo.py \
305 9d1b963f Michael Hanselmann
	lib/utils/filelock.py \
306 f21bb4b7 Michael Hanselmann
	lib/utils/hash.py \
307 3865ca48 Michael Hanselmann
	lib/utils/io.py \
308 1ae4c5a1 Michael Hanselmann
	lib/utils/log.py \
309 8dc76d54 Guido Trotter
	lib/utils/mlock.py \
310 17b97ab3 Michael Hanselmann
	lib/utils/nodesetup.py \
311 a4ccecf6 Michael Hanselmann
	lib/utils/process.py \
312 7fcffe27 Michael Hanselmann
	lib/utils/retry.py \
313 7831fc5f Michael Hanselmann
	lib/utils/text.py \
314 c50645c0 Michael Hanselmann
	lib/utils/wrapper.py \
315 c50645c0 Michael Hanselmann
	lib/utils/x509.py
316 c047a981 Michael Hanselmann
317 f05c99f3 Michael Hanselmann
docrst = \
318 ffa6869f Iustin Pop
	doc/admin.rst \
319 5c0c1eeb Iustin Pop
	doc/design-2.0.rst \
320 4f366caf Michael Hanselmann
	doc/design-2.1.rst \
321 e56bb0e8 Guido Trotter
	doc/design-2.2.rst \
322 1eb85930 Guido Trotter
	doc/design-2.3.rst \
323 92902e91 Iustin Pop
	doc/design-htools-2.3.rst \
324 78b40c5e Michael Hanselmann
	doc/design-2.4.rst \
325 d774ce92 Michael Hanselmann
	doc/design-2.5.rst \
326 c95c0f71 Michael Hanselmann
	doc/design-draft.rst \
327 1e86ee97 Marc Schmitt
	doc/design-oob.rst \
328 ae9b5e0f Tsachy Shacham
	doc/design-cpu-pinning.rst \
329 e5a246df Michael Hanselmann
	doc/design-query2.rst \
330 539f195a Michael Hanselmann
	doc/design-x509-ca.rst \
331 278ddaa9 Michael Hanselmann
	doc/design-http-server.rst \
332 1375e1d9 Michael Hanselmann
	doc/design-impexp2.rst \
333 ed9fda24 Michael Hanselmann
	doc/design-lu-generated-jobs.rst \
334 4055b109 Adeodato Simo
	doc/design-multi-reloc.rst \
335 eec83a95 Apollon Oikonomopoulos
	doc/design-network.rst \
336 6c3d18e0 Michael Hanselmann
	doc/design-chained-jobs.rst \
337 64ea845e Michael Hanselmann
	doc/design-ovf-support.rst \
338 d85f01e7 Iustin Pop
	doc/design-resource-model.rst \
339 d9bdffc3 René Nussbaumer
	doc/cluster-merge.rst \
340 a997cec5 Apollon Oikonomopoulos
	doc/design-shared-storage.rst \
341 23f0b93e René Nussbaumer
	doc/design-node-state-cache.rst \
342 6b898285 Iustin Pop
	doc/design-virtual-clusters.rst \
343 62947ebb Michael Hanselmann
	doc/devnotes.rst \
344 e2078d28 Iustin Pop
	doc/glossary.rst \
345 4d6443f4 Iustin Pop
	doc/hooks.rst \
346 876860a3 Iustin Pop
	doc/iallocator.rst \
347 d17e74b4 Iustin Pop
	doc/index.rst \
348 cbf3d64b Michael Hanselmann
	doc/install-quick.rst \
349 28e15341 Iustin Pop
	doc/install.rst \
350 9725b53d Michael Hanselmann
	doc/locking.rst \
351 6bf273d5 Michael Hanselmann
	doc/move-instance.rst \
352 c71a1a3d Iustin Pop
	doc/news.rst \
353 6d81475c Iustin Pop
	doc/rapi.rst \
354 b76aac08 Michael Hanselmann
	doc/security.rst \
355 35dd762d Michael Hanselmann
	doc/upgrade.rst \
356 c71a1a3d Iustin Pop
	doc/walkthrough.rst
357 f05c99f3 Michael Hanselmann
358 0985325d Iustin Pop
HS_PROGS = htools/htools
359 2922d2c5 René Nussbaumer
HS_BIN_ROLES = hbal hscan hspace hinfo
360 d6159933 Iustin Pop
361 73b0fa69 Iustin Pop
HS_ALL_PROGS = $(HS_PROGS) htools/test htools/hpc-htools htools/hconfd
362 c3f67183 Iustin Pop
HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
363 3096524e Iustin Pop
HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/%) test/hail
364 3096524e Iustin Pop
365 74e60746 Iustin Pop
HFLAGS = -O -Wall -Werror -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
366 74e60746 Iustin Pop
# extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
367 d6159933 Iustin Pop
HEXTRA =
368 c7ec3025 Iustin Pop
# internal extra flags (used for htools/test mainly)
369 c7ec3025 Iustin Pop
HEXTRA_INT =
370 b91e9518 Iustin Pop
# exclude options for coverage reports
371 9822b1dd Iustin Pop
HPCEXCL = --exclude Main \
372 98b33d0e Iustin Pop
	--exclude Ganeti.Constants \
373 9822b1dd Iustin Pop
	--exclude Ganeti.THH \
374 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QC \
375 9822b1dd Iustin Pop
	--exclude Ganeti.HTools.QCHelper \
376 98b33d0e Iustin Pop
	--exclude Ganeti.HTools.Version
377 d6159933 Iustin Pop
378 c3f67183 Iustin Pop
HS_LIB_SRCS = \
379 d6159933 Iustin Pop
	htools/Ganeti/HTools/CLI.hs \
380 d6159933 Iustin Pop
	htools/Ganeti/HTools/Cluster.hs \
381 1adec4be Iustin Pop
	htools/Ganeti/HTools/Compat.hs \
382 d6159933 Iustin Pop
	htools/Ganeti/HTools/Container.hs \
383 d6159933 Iustin Pop
	htools/Ganeti/HTools/ExtLoader.hs \
384 d6159933 Iustin Pop
	htools/Ganeti/HTools/Group.hs \
385 d6159933 Iustin Pop
	htools/Ganeti/HTools/IAlloc.hs \
386 d6159933 Iustin Pop
	htools/Ganeti/HTools/Instance.hs \
387 f047f90f Iustin Pop
	htools/Ganeti/HTools/JSON.hs \
388 d6159933 Iustin Pop
	htools/Ganeti/HTools/Loader.hs \
389 d6159933 Iustin Pop
	htools/Ganeti/HTools/Luxi.hs \
390 d6159933 Iustin Pop
	htools/Ganeti/HTools/Node.hs \
391 d6159933 Iustin Pop
	htools/Ganeti/HTools/PeerMap.hs \
392 d6159933 Iustin Pop
	htools/Ganeti/HTools/QC.hs \
393 9822b1dd Iustin Pop
	htools/Ganeti/HTools/QCHelper.hs \
394 d6159933 Iustin Pop
	htools/Ganeti/HTools/Rapi.hs \
395 d6159933 Iustin Pop
	htools/Ganeti/HTools/Simu.hs \
396 d6159933 Iustin Pop
	htools/Ganeti/HTools/Text.hs \
397 d6159933 Iustin Pop
	htools/Ganeti/HTools/Types.hs \
398 d6159933 Iustin Pop
	htools/Ganeti/HTools/Utils.hs \
399 9f13be88 Iustin Pop
	htools/Ganeti/HTools/Program.hs \
400 458a286a Iustin Pop
	htools/Ganeti/HTools/Program/Hail.hs \
401 201b6c34 Iustin Pop
	htools/Ganeti/HTools/Program/Hbal.hs \
402 2922d2c5 René Nussbaumer
	htools/Ganeti/HTools/Program/Hinfo.hs \
403 7b695a0d Iustin Pop
	htools/Ganeti/HTools/Program/Hscan.hs \
404 1494a4cc Iustin Pop
	htools/Ganeti/HTools/Program/Hspace.hs \
405 0c37d1e4 Iustin Pop
	htools/Ganeti/BasicTypes.hs \
406 417cc253 Iustin Pop
	htools/Ganeti/Confd.hs \
407 358a0a8f Iustin Pop
	htools/Ganeti/Confd/Server.hs \
408 eaa64cd8 Iustin Pop
	htools/Ganeti/Config.hs \
409 6ec7a50e Iustin Pop
	htools/Ganeti/Daemon.hs \
410 21dc8694 Iustin Pop
	htools/Ganeti/Hash.hs \
411 d6159933 Iustin Pop
	htools/Ganeti/Jobs.hs \
412 ba4e38e8 Iustin Pop
	htools/Ganeti/Logging.hs \
413 d6159933 Iustin Pop
	htools/Ganeti/Luxi.hs \
414 b1e81520 Iustin Pop
	htools/Ganeti/Objects.hs \
415 e9aaa3c6 Iustin Pop
	htools/Ganeti/OpCodes.hs \
416 7946c25d Iustin Pop
	htools/Ganeti/Runtime.hs \
417 aa3adf35 Iustin Pop
	htools/Ganeti/Ssconf.hs \
418 e9aaa3c6 Iustin Pop
	htools/Ganeti/THH.hs
419 d6159933 Iustin Pop
420 d99d1e36 Iustin Pop
HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs htools/Ganeti/Constants.hs
421 c3f67183 Iustin Pop
HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
422 d6159933 Iustin Pop
423 c964d962 Michael Hanselmann
$(RUN_IN_TEMPDIR): | $(all_dirfiles)
424 c964d962 Michael Hanselmann
425 a2d917f3 Iustin Pop
# Note: we use here an order-only prerequisite, as the contents of
426 a2d917f3 Iustin Pop
# _autoconf.py are not actually influencing the html build output: it
427 a2d917f3 Iustin Pop
# has to exist in order for the sphinx module to be loaded
428 a2d917f3 Iustin Pop
# successfully, but we certainly don't want the docs to be rebuilt if
429 a2d917f3 Iustin Pop
# it changes
430 c964d962 Michael Hanselmann
doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
431 7142485a Iustin Pop
	$(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
432 7142485a Iustin Pop
	lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
433 08366664 Michael Hanselmann
	| $(BUILT_PYTHON_SOURCES)
434 d17e74b4 Iustin Pop
	@test -n "$(SPHINX)" || \
435 d17e74b4 Iustin Pop
	    { echo 'sphinx-build' not found during configure; exit 1; }
436 2750b299 Michael Hanselmann
	@mkdir_p@ $(dir $@)
437 e7f6524c Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
438 13de7d59 Michael Hanselmann
	    -d . \
439 d17e74b4 Iustin Pop
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
440 d17e74b4 Iustin Pop
	    -D release="$(PACKAGE_VERSION)" \
441 13de7d59 Michael Hanselmann
	    $(abs_top_srcdir)/doc $(CURDIR)/doc/html
442 13de7d59 Michael Hanselmann
	rm -f doc/html/.buildinfo doc/html/objects.inv
443 13de7d59 Michael Hanselmann
	touch $@
444 13de7d59 Michael Hanselmann
445 c964d962 Michael Hanselmann
doc/html: doc/html/index.html
446 2ab2b9f5 Iustin Pop
447 cbf3d64b Michael Hanselmann
doc/install-quick.rst: INSTALL
448 b76aac08 Michael Hanselmann
doc/news.rst: NEWS
449 7a03d293 Michael Hanselmann
doc/upgrade.rst: UPGRADE
450 b76aac08 Michael Hanselmann
451 e8deef56 Michael Hanselmann
doc/install-quick.rst doc/news.rst doc/upgrade.rst:
452 cbf3d64b Michael Hanselmann
	set -e; \
453 cbf3d64b Michael Hanselmann
	{ echo '.. This file is automatically updated at build time from $<.'; \
454 cbf3d64b Michael Hanselmann
	  echo '.. Do not edit.'; \
455 cbf3d64b Michael Hanselmann
	  echo; \
456 cbf3d64b Michael Hanselmann
	  cat $<; \
457 cbf3d64b Michael Hanselmann
	} > $@
458 cbf3d64b Michael Hanselmann
459 b8195800 Iustin Pop
docdot = \
460 ca9ccea8 Michael Hanselmann
	doc/arch-2.0.dot \
461 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-acquire.dot \
462 ca9ccea8 Michael Hanselmann
	doc/design-2.1-lock-release.dot
463 b8195800 Iustin Pop
464 d17e74b4 Iustin Pop
docpng = $(patsubst %.dot,%.png,$(docdot))
465 e8230860 Michael Hanselmann
466 7e1ccbe0 Michael Hanselmann
# Things to build but not to install (add it to EXTRA_DIST if it should be
467 7e1ccbe0 Michael Hanselmann
# distributed)
468 7e1ccbe0 Michael Hanselmann
noinst_DATA = \
469 7e1ccbe0 Michael Hanselmann
	devel/upload \
470 7e1ccbe0 Michael Hanselmann
	doc/html \
471 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES) \
472 7e1ccbe0 Michael Hanselmann
	doc/examples/bash_completion \
473 7e1ccbe0 Michael Hanselmann
	$(manhtml)
474 f29266b4 Iustin Pop
475 4f3d5b76 Michael Hanselmann
gnt_scripts = \
476 e8230860 Michael Hanselmann
	scripts/gnt-backup \
477 e8230860 Michael Hanselmann
	scripts/gnt-cluster \
478 e8230860 Michael Hanselmann
	scripts/gnt-debug \
479 667dbd6b Adeodato Simo
	scripts/gnt-group \
480 e8230860 Michael Hanselmann
	scripts/gnt-instance \
481 e8230860 Michael Hanselmann
	scripts/gnt-job \
482 e8230860 Michael Hanselmann
	scripts/gnt-node \
483 e8230860 Michael Hanselmann
	scripts/gnt-os
484 e8230860 Michael Hanselmann
485 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP_SBIN = \
486 29d91329 Michael Hanselmann
	daemons/ganeti-masterd \
487 5119f2ec Michael Hanselmann
	daemons/ganeti-noded \
488 9f4bb951 Michael Hanselmann
	daemons/ganeti-watcher \
489 d9c82a4e Michael Hanselmann
	daemons/ganeti-rapi \
490 656a7fdf Iustin Pop
	$(gnt_scripts)
491 2d48a3a2 Michael Hanselmann
492 73b0fa69 Iustin Pop
if PY_CONFD
493 73b0fa69 Iustin Pop
PYTHON_BOOTSTRAP_SBIN += daemons/ganeti-confd
494 73b0fa69 Iustin Pop
endif
495 73b0fa69 Iustin Pop
496 0d2bf835 René Nussbaumer
PYTHON_BOOTSTRAP = \
497 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
498 0d2bf835 René Nussbaumer
	tools/ensure-dirs
499 0d2bf835 René Nussbaumer
500 a8c68e44 Michael Hanselmann
qa_scripts = \
501 a8c68e44 Michael Hanselmann
	qa/ganeti-qa.py \
502 a8c68e44 Michael Hanselmann
	qa/qa_cluster.py \
503 a8c68e44 Michael Hanselmann
	qa/qa_config.py \
504 a8c68e44 Michael Hanselmann
	qa/qa_daemon.py \
505 a8c68e44 Michael Hanselmann
	qa/qa_env.py \
506 a8c68e44 Michael Hanselmann
	qa/qa_error.py \
507 21bf2e2e Andrea Spadaccini
	qa/qa_group.py \
508 a8c68e44 Michael Hanselmann
	qa/qa_instance.py \
509 a8c68e44 Michael Hanselmann
	qa/qa_node.py \
510 a8c68e44 Michael Hanselmann
	qa/qa_os.py \
511 a8c68e44 Michael Hanselmann
	qa/qa_rapi.py \
512 a8c68e44 Michael Hanselmann
	qa/qa_tags.py \
513 a8c68e44 Michael Hanselmann
	qa/qa_utils.py
514 a8c68e44 Michael Hanselmann
515 d6159933 Iustin Pop
bin_SCRIPTS =
516 d6159933 Iustin Pop
if WANT_HTOOLS
517 c3f67183 Iustin Pop
bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
518 458a286a Iustin Pop
install-exec-hook:
519 458a286a Iustin Pop
	@mkdir_p@ $(DESTDIR)$(iallocatorsdir)
520 7fa52acd Iustin Pop
# FIXME: this is a hardcoded logic, instead of auto-resolving
521 7fa52acd Iustin Pop
	$(LN_S) -f ../../../bin/htools \
522 458a286a Iustin Pop
		   $(DESTDIR)$(iallocatorsdir)/hail
523 201b6c34 Iustin Pop
	for role in $(HS_BIN_ROLES); do \
524 7fa52acd Iustin Pop
		$(LN_S) -f htools \
525 201b6c34 Iustin Pop
			   $(DESTDIR)$(bindir)/$$role ; \
526 201b6c34 Iustin Pop
	done
527 73b0fa69 Iustin Pop
if HS_CONFD
528 73b0fa69 Iustin Pop
	mv $(DESTDIR)$(sbindir)/hconfd $(DESTDIR)$(sbindir)/ganeti-confd
529 73b0fa69 Iustin Pop
endif
530 d6159933 Iustin Pop
endif
531 d6159933 Iustin Pop
532 c3f67183 Iustin Pop
$(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
533 16a6192d Iustin Pop
	@if [ -z "$(HTOOLS)" ]; then \
534 16a6192d Iustin Pop
	  echo "Error: htools compilation disabled at configure time" 1>&2 ;\
535 16a6192d Iustin Pop
	  exit 1; \
536 16a6192d Iustin Pop
	fi
537 49e11c49 Iustin Pop
	@BINARY=$(@:htools/%=%); \
538 49e11c49 Iustin Pop
	if [ "$BINARY" = "test" ] && [ -z "$(GHC_PKG_QUICKCHECK)" ]; then \
539 fd0bc853 Iustin Pop
	  echo "Error: cannot run unittests without the QuickCheck library (see devnotes.rst)" 1>&2; \
540 fd0bc853 Iustin Pop
	  exit 1; \
541 49e11c49 Iustin Pop
	fi
542 a593113c Iustin Pop
	rm -f $(@:htools/%=%).tix
543 49e11c49 Iustin Pop
	BINARY=$(@:htools/%=%); $(GHC) --make \
544 ef958f2a Iustin Pop
	  $(HFLAGS) \
545 1adec4be Iustin Pop
	  $(HTOOLS_NOCURL) $(HTOOLS_PARALLEL3) \
546 ef958f2a Iustin Pop
	  -osuf $$BINARY.o -hisuf $$BINARY.hi \
547 c7ec3025 Iustin Pop
	  $(HEXTRA) $(HEXTRA_INT) $@
548 b91e9518 Iustin Pop
# for the htools/test binary, we need to enable profiling/coverage
549 c7ec3025 Iustin Pop
htools/test: HEXTRA_INT=-fhpc -Wwarn -fno-warn-missing-signatures \
550 b91e9518 Iustin Pop
	-fno-warn-monomorphism-restriction -fno-warn-orphans \
551 b91e9518 Iustin Pop
	-fno-warn-missing-methods -fno-warn-unused-imports
552 b91e9518 Iustin Pop
553 896b2850 Iustin Pop
# we compile the hpc-htools binary with the program coverage
554 896b2850 Iustin Pop
htools/hpc-htools: HEXTRA_INT=-fhpc
555 25cdf177 Iustin Pop
556 04d15e63 Iustin Pop
# test dependency
557 896b2850 Iustin Pop
htools/offline-tests.sh: htools/hpc-htools
558 04d15e63 Iustin Pop
559 c7ec3025 Iustin Pop
# rules for building profiling-enabled versions of the haskell
560 c7ec3025 Iustin Pop
# programs: hs-prof does the full two-step build, whereas
561 c7ec3025 Iustin Pop
# hs-prof-quick does only the final rebuild (hs-prof must have been
562 c7ec3025 Iustin Pop
# run before)
563 c7ec3025 Iustin Pop
.PHONY: hs-prof hs-prof-quick
564 c7ec3025 Iustin Pop
hs-prof:
565 c7ec3025 Iustin Pop
	$(MAKE) clean
566 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .o"
567 c7ec3025 Iustin Pop
	rm -f $(HS_ALL_PROGS)
568 c7ec3025 Iustin Pop
	$(MAKE) hs-prof-quick
569 c7ec3025 Iustin Pop
570 c7ec3025 Iustin Pop
hs-prof-quick:
571 c7ec3025 Iustin Pop
	$(MAKE) $(HS_ALL_PROGS) HEXTRA="-osuf .prof_o -prof -auto-all"
572 c7ec3025 Iustin Pop
573 da7e44ee Michael Hanselmann
dist_sbin_SCRIPTS = \
574 da7e44ee Michael Hanselmann
	tools/ganeti-listrunner
575 4f3d5b76 Michael Hanselmann
576 fc3fd894 Michael Hanselmann
nodist_sbin_SCRIPTS = \
577 0d2bf835 René Nussbaumer
	$(PYTHON_BOOTSTRAP_SBIN) \
578 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner
579 fc3fd894 Michael Hanselmann
580 73b0fa69 Iustin Pop
if HS_CONFD
581 73b0fa69 Iustin Pop
nodist_sbin_SCRIPTS += htools/hconfd
582 73b0fa69 Iustin Pop
endif
583 73b0fa69 Iustin Pop
584 cc120286 Bernardo Dal Seno
python_scripts = \
585 e8230860 Michael Hanselmann
	tools/burnin \
586 e8230860 Michael Hanselmann
	tools/cfgshell \
587 e8230860 Michael Hanselmann
	tools/cfgupgrade \
588 b5672ea0 Iustin Pop
	tools/cfgupgrade12 \
589 1f7d3f7d René Nussbaumer
	tools/cluster-merge \
590 4ef0399b Iustin Pop
	tools/confd-client \
591 d62cbd3a Michael Hanselmann
	tools/fmtjson \
592 ea5fd476 Iustin Pop
	tools/lvmstrap \
593 6bf273d5 Michael Hanselmann
	tools/move-instance \
594 ced78a66 Agata Murawska
	tools/ovfconverter \
595 05cd934d René Nussbaumer
	tools/setup-ssh \
596 ea5fd476 Iustin Pop
	tools/sanitize-config
597 e8230860 Michael Hanselmann
598 61631293 Stephen Shirley
dist_tools_SCRIPTS = \
599 cc120286 Bernardo Dal Seno
	$(python_scripts) \
600 2f4c951e Stephen Shirley
	tools/kvm-console-wrapper \
601 d9eefcfa Andrea Spadaccini
	tools/xm-console-wrapper \
602 d9eefcfa Andrea Spadaccini
	tools/master-ip-setup
603 61631293 Stephen Shirley
604 2d76b580 Michael Hanselmann
pkglib_python_scripts = \
605 c6ccba7e Michael Hanselmann
	daemons/import-export \
606 c6ccba7e Michael Hanselmann
	tools/check-cert-expired
607 2d76b580 Michael Hanselmann
608 0d2bf835 René Nussbaumer
nodist_pkglib_python_scripts = \
609 0d2bf835 René Nussbaumer
	tools/ensure-dirs
610 0d2bf835 René Nussbaumer
611 b8fe7ca6 Iustin Pop
myexeclib_SCRIPTS = \
612 2d76b580 Michael Hanselmann
	daemons/daemon-util \
613 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup \
614 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts)
615 f154a7a3 Michael Hanselmann
616 b8fe7ca6 Iustin Pop
nodist_myexeclib_SCRIPTS = \
617 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts)
618 0d2bf835 René Nussbaumer
619 e8230860 Michael Hanselmann
EXTRA_DIST = \
620 e8230860 Michael Hanselmann
	NEWS \
621 7a03d293 Michael Hanselmann
	UPGRADE \
622 f774bd03 Michael Hanselmann
	epydoc.conf.in \
623 70c771f6 Michael Hanselmann
	pylintrc \
624 bb46a96c Michael Hanselmann
	autotools/build-bash-completion \
625 d5a2a550 Michael Hanselmann
	autotools/build-rpc \
626 5d3c30df Michael Hanselmann
	autotools/check-header \
627 eed5c5df Michael Hanselmann
	autotools/check-python-code \
628 f6cbcc06 Michael Hanselmann
	autotools/check-imports \
629 c55cc346 Iustin Pop
	autotools/check-man-dashes \
630 73d0e218 Iustin Pop
	autotools/check-man-warnings \
631 c81ed2b2 Michael Hanselmann
	autotools/check-news \
632 e627fe09 Michael Hanselmann
	autotools/check-tar \
633 96602be4 Michael Hanselmann
	autotools/check-version \
634 d99d1e36 Iustin Pop
	autotools/convert-constants \
635 95eb4188 Michael Hanselmann
	autotools/docpp \
636 27e336af Michael Hanselmann
	autotools/gen-coverage \
637 df69e0a0 Bernardo Dal Seno
	autotools/testrunner \
638 f3313af5 Guido Trotter
	$(RUN_IN_TEMPDIR) \
639 f154a7a3 Michael Hanselmann
	daemons/daemon-util.in \
640 fc3fd894 Michael Hanselmann
	daemons/ganeti-cleaner.in \
641 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
642 e8230860 Michael Hanselmann
	devel/upload.in \
643 26916aad Apollon Oikonomopoulos
	tools/kvm-ifup.in \
644 b8195800 Iustin Pop
	$(docdot) \
645 f727d134 Michael Hanselmann
	$(docpng) \
646 d17e74b4 Iustin Pop
	$(docrst) \
647 d17e74b4 Iustin Pop
	doc/conf.py \
648 d17e74b4 Iustin Pop
	doc/html \
649 656a7fdf Iustin Pop
	$(BUILT_EXAMPLES:%=%.in) \
650 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default \
651 752a8ca8 Michael Hanselmann
	doc/examples/ganeti.default-debug \
652 d6d9ce45 Guido Trotter
	doc/examples/hooks/ethers \
653 89c04c2d Guido Trotter
	doc/examples/gnt-debug/README \
654 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay0.json \
655 89c04c2d Guido Trotter
	doc/examples/gnt-debug/delay50.json \
656 e4d452b4 Michael Hanselmann
	test/lockperf.py \
657 e8230860 Michael Hanselmann
	test/testutils.py \
658 e8230860 Michael Hanselmann
	test/mocks.py \
659 e8230860 Michael Hanselmann
	$(dist_TESTS) \
660 e8230860 Michael Hanselmann
	$(TEST_FILES) \
661 6be8e2bf Iustin Pop
	man/footer.rst \
662 6be8e2bf Iustin Pop
	$(manrst) \
663 f727d134 Michael Hanselmann
	$(maninput) \
664 39e0d19e Michael Hanselmann
	qa/qa-sample.json \
665 d6159933 Iustin Pop
	$(qa_scripts) \
666 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
667 5a1e31b4 Iustin Pop
	$(HS_PROG_SRCS) \
668 04d15e63 Iustin Pop
	htools/lint-hints.hs \
669 04d15e63 Iustin Pop
	htools/cli-tests-defs.sh \
670 04d15e63 Iustin Pop
	htools/offline-test.sh
671 e8230860 Michael Hanselmann
672 e8230860 Michael Hanselmann
man_MANS = \
673 e8230860 Michael Hanselmann
	man/ganeti.7 \
674 bae7e531 Michael Hanselmann
	man/ganeti-cleaner.8 \
675 b7b7cda6 Guido Trotter
	man/ganeti-confd.8 \
676 da7e44ee Michael Hanselmann
	man/ganeti-listrunner.8 \
677 320d986d Iustin Pop
	man/ganeti-masterd.8 \
678 e8230860 Michael Hanselmann
	man/ganeti-noded.8 \
679 e8230860 Michael Hanselmann
	man/ganeti-os-interface.7 \
680 320d986d Iustin Pop
	man/ganeti-rapi.8 \
681 e8230860 Michael Hanselmann
	man/ganeti-watcher.8 \
682 e8230860 Michael Hanselmann
	man/gnt-backup.8 \
683 e8230860 Michael Hanselmann
	man/gnt-cluster.8 \
684 d3b4cf9f Iustin Pop
	man/gnt-debug.8 \
685 667dbd6b Adeodato Simo
	man/gnt-group.8 \
686 e8230860 Michael Hanselmann
	man/gnt-instance.8 \
687 d3b4cf9f Iustin Pop
	man/gnt-job.8 \
688 e8230860 Michael Hanselmann
	man/gnt-node.8 \
689 5a19bd35 Iustin Pop
	man/gnt-os.8 \
690 5a19bd35 Iustin Pop
	man/hail.1 \
691 5a19bd35 Iustin Pop
	man/hbal.1 \
692 e2bdaf25 René Nussbaumer
	man/hinfo.1 \
693 5a19bd35 Iustin Pop
	man/hscan.1 \
694 d26d808a Iustin Pop
	man/hspace.1 \
695 d26d808a Iustin Pop
	man/htools.1
696 e8230860 Michael Hanselmann
697 5a19bd35 Iustin Pop
manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
698 6be8e2bf Iustin Pop
manhtml = $(patsubst %.rst,%.html,$(manrst))
699 fcdb582d Michael Hanselmann
mangen = $(patsubst %.rst,%.gen,$(manrst))
700 25c92bc5 Michael Hanselmann
maninput = \
701 5a19bd35 Iustin Pop
	$(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
702 de8eea3e Iustin Pop
	$(patsubst %.html,%.html.in,$(manhtml)) \
703 fcdb582d Michael Hanselmann
	man/footer.man man/footer.html $(mangen)
704 e8230860 Michael Hanselmann
705 e8230860 Michael Hanselmann
TEST_FILES = \
706 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.0.txt \
707 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-8.3.txt \
708 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-disk.txt \
709 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip4.txt \
710 5a672c30 Manuel Franceschini
	test/data/bdev-drbd-net-ip6.txt \
711 27e46076 Michael Hanselmann
	test/data/cert1.pem \
712 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-dummy0.txt \
713 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv4.txt \
714 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-ipv6.txt \
715 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv4.txt \
716 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline-ipv6.txt \
717 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo-oneline.txt \
718 e5d1d1b5 Andrea Spadaccini
	test/data/ip-addr-show-lo.txt \
719 d816408a Iustin Pop
	test/data/proc_drbd8.txt \
720 a6ac80db Iustin Pop
	test/data/proc_drbd80-emptyline.txt \
721 2d76b580 Michael Hanselmann
	test/data/proc_drbd83.txt \
722 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync.txt \
723 7a380ddf René Nussbaumer
	test/data/proc_drbd83_sync_krnl2.6.39.txt \
724 585c8187 Guido Trotter
	test/data/kvm_1.0_help.txt \
725 585c8187 Guido Trotter
	test/data/kvm_0.15.90_help.txt \
726 585c8187 Guido Trotter
	test/data/kvm_0.12.5_help.txt \
727 585c8187 Guido Trotter
	test/data/kvm_0.9.1_help.txt \
728 549071a0 Luca Bigliardi
	test/data/sys_drbd_usermode_helper.txt \
729 6bbd76d2 Iustin Pop
	test/data/htools/hail-alloc-drbd.json \
730 6bbd76d2 Iustin Pop
	test/data/htools/hail-change-group.json \
731 3e5012c6 Iustin Pop
	test/data/htools/hail-invalid-reloc.json \
732 6bbd76d2 Iustin Pop
	test/data/htools/hail-node-evac.json \
733 6bbd76d2 Iustin Pop
	test/data/htools/hail-reloc-drbd.json \
734 9915fb20 Iustin Pop
	test/data/htools/common-suffix.data \
735 9915fb20 Iustin Pop
	test/data/htools/invalid-node.data \
736 9915fb20 Iustin Pop
	test/data/htools/missing-resources.data \
737 55ffacfa Iustin Pop
	test/data/htools/rapi/groups.json \
738 55ffacfa Iustin Pop
	test/data/htools/rapi/info.json \
739 55ffacfa Iustin Pop
	test/data/htools/rapi/instances.json \
740 55ffacfa Iustin Pop
	test/data/htools/rapi/nodes.json \
741 1e6fab60 Agata Murawska
	test/data/ovfdata/compr_disk.vmdk.gz \
742 d92518d3 Agata Murawska
	test/data/ovfdata/config.ini \
743 1e6fab60 Agata Murawska
	test/data/ovfdata/corrupted_resources.ovf \
744 d92518d3 Agata Murawska
	test/data/ovfdata/empty.ini \
745 1e6fab60 Agata Murawska
	test/data/ovfdata/empty.ovf \
746 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.mf \
747 1e6fab60 Agata Murawska
	test/data/ovfdata/ganeti.ovf \
748 1e6fab60 Agata Murawska
	test/data/ovfdata/gzip_disk.ovf \
749 1e6fab60 Agata Murawska
	test/data/ovfdata/new_disk.vmdk \
750 d92518d3 Agata Murawska
	test/data/ovfdata/no_disk.ini \
751 1e6fab60 Agata Murawska
	test/data/ovfdata/no_disk_in_ref.ovf \
752 d92518d3 Agata Murawska
	test/data/ovfdata/no_os.ini \
753 1e6fab60 Agata Murawska
	test/data/ovfdata/no_ovf.ova \
754 1e6fab60 Agata Murawska
	test/data/ovfdata/ova.ova \
755 1e6fab60 Agata Murawska
	test/data/ovfdata/second_disk.vmdk \
756 d92518d3 Agata Murawska
	test/data/ovfdata/rawdisk.raw \
757 d92518d3 Agata Murawska
	test/data/ovfdata/unsafe_path.ini \
758 1e6fab60 Agata Murawska
	test/data/ovfdata/virtualbox.ovf \
759 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_extension.ovd \
760 d92518d3 Agata Murawska
	test/data/ovfdata/wrong_config.ini \
761 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.mf \
762 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_manifest.ovf \
763 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_ova.ova \
764 1e6fab60 Agata Murawska
	test/data/ovfdata/wrong_xml.ovf \
765 d92518d3 Agata Murawska
	test/data/ovfdata/other/rawdisk.raw \
766 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.02.txt \
767 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-fail.txt \
768 1a1e7ab3 Iustin Pop
	test/data/vgreduce-removemissing-2.02.66-ok.txt \
769 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.02.txt \
770 1a1e7ab3 Iustin Pop
	test/data/vgs-missing-pvs-2.02.66.txt \
771 53d4cdf1 Iustin Pop
	test/import-export_unittest-helper \
772 30f2802f Iustin Pop
	test/gnt-cli.test \
773 30f2802f Iustin Pop
	test/ganeti-cli.test \
774 53d4cdf1 Iustin Pop
	test/htools-balancing.test \
775 53d4cdf1 Iustin Pop
	test/htools-basic.test \
776 53d4cdf1 Iustin Pop
	test/htools-dynutil.test \
777 53d4cdf1 Iustin Pop
	test/htools-excl.test \
778 53d4cdf1 Iustin Pop
	test/htools-hail.test \
779 53d4cdf1 Iustin Pop
	test/htools-hspace.test \
780 53d4cdf1 Iustin Pop
	test/htools-invalid.test \
781 53d4cdf1 Iustin Pop
	test/htools-multi-group.test \
782 53d4cdf1 Iustin Pop
	test/htools-no-backend.test \
783 53d4cdf1 Iustin Pop
	test/htools-rapi.test \
784 53d4cdf1 Iustin Pop
	test/htools-single-group.test \
785 53d4cdf1 Iustin Pop
	test/htools-text-backend.test
786 e8230860 Michael Hanselmann
787 e8c8cf1a Michael Hanselmann
python_tests = \
788 17496050 Guido Trotter
	test/ganeti.asyncnotifier_unittest.py \
789 f942a838 Michael Hanselmann
	test/ganeti.backend_unittest.py \
790 6de7c41d Iustin Pop
	test/ganeti.bdev_unittest.py \
791 6de7c41d Iustin Pop
	test/ganeti.cli_unittest.py \
792 66d1f035 René Nussbaumer
	test/ganeti.client.gnt_cluster_unittest.py \
793 25ce3ec4 Michael Hanselmann
	test/ganeti.client.gnt_instance_unittest.py \
794 1118ec44 Guido Trotter
	test/ganeti.daemon_unittest.py \
795 6de7c41d Iustin Pop
	test/ganeti.cmdlib_unittest.py \
796 cea881e5 Michael Hanselmann
	test/ganeti.compat_unittest.py \
797 edf7d66e Iustin Pop
	test/ganeti.confd.client_unittest.py \
798 e8230860 Michael Hanselmann
	test/ganeti.config_unittest.py \
799 6de7c41d Iustin Pop
	test/ganeti.constants_unittest.py \
800 3bd19c66 Michael Hanselmann
	test/ganeti.errors_unittest.py \
801 e8230860 Michael Hanselmann
	test/ganeti.hooks_unittest.py \
802 ecdf0398 Michael Hanselmann
	test/ganeti.ht_unittest.py \
803 6de7c41d Iustin Pop
	test/ganeti.http_unittest.py \
804 b7d82e40 Iustin Pop
	test/ganeti.hypervisor_unittest.py \
805 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_chroot_unittest.py \
806 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_fake_unittest.py \
807 748e4b5a Michael Hanselmann
	test/ganeti.hypervisor.hv_kvm_unittest.py \
808 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_lxc_unittest.py \
809 55cc0a44 Michael Hanselmann
	test/ganeti.hypervisor.hv_xen_unittest.py \
810 bb44b1ae Michael Hanselmann
	test/ganeti.impexpd_unittest.py \
811 989a8bee Michael Hanselmann
	test/ganeti.jqueue_unittest.py \
812 e8230860 Michael Hanselmann
	test/ganeti.locking_unittest.py \
813 231db3a5 Michael Hanselmann
	test/ganeti.luxi_unittest.py \
814 033a1d00 Michael Hanselmann
	test/ganeti.masterd.instance_unittest.py \
815 407339d0 Michael Hanselmann
	test/ganeti.mcpu_unittest.py \
816 a744b676 Manuel Franceschini
	test/ganeti.netutils_unittest.py \
817 4c14965f Guido Trotter
	test/ganeti.objects_unittest.py \
818 c32b908e Michael Hanselmann
	test/ganeti.opcodes_unittest.py \
819 1e6fab60 Agata Murawska
	test/ganeti.ovf_unittest.py \
820 a123dc19 Michael Hanselmann
	test/ganeti.qlang_unittest.py \
821 4ca96421 Michael Hanselmann
	test/ganeti.query_unittest.py \
822 cfaeaaf7 Michael Hanselmann
	test/ganeti.rapi.baserlib_unittest.py \
823 95ab4de9 David Knowles
	test/ganeti.rapi.client_unittest.py \
824 4cbd4462 Oleksiy Mishchenko
	test/ganeti.rapi.resources_unittest.py \
825 6395cebb Michael Hanselmann
	test/ganeti.rapi.rlib2_unittest.py \
826 a85f23fa Michael Hanselmann
	test/ganeti.rapi.testutils_unittest.py \
827 33231500 Michael Hanselmann
	test/ganeti.rpc_unittest.py \
828 f12e1736 René Nussbaumer
	test/ganeti.runtime_unittest.py \
829 6de7c41d Iustin Pop
	test/ganeti.serializer_unittest.py \
830 6de7c41d Iustin Pop
	test/ganeti.ssh_unittest.py \
831 048eeb2b Iustin Pop
	test/ganeti.storage_unittest.py \
832 0d2bf835 René Nussbaumer
	test/ganeti.tools.ensure_dirs_unittest.py \
833 93be53da Balazs Lecz
	test/ganeti.uidpool_unittest.py \
834 4fd029cf Michael Hanselmann
	test/ganeti.utils.algo_unittest.py \
835 9d1b963f Michael Hanselmann
	test/ganeti.utils.filelock_unittest.py \
836 f21bb4b7 Michael Hanselmann
	test/ganeti.utils.hash_unittest.py \
837 3865ca48 Michael Hanselmann
	test/ganeti.utils.io_unittest.py \
838 b6fa9a44 Michael Hanselmann
	test/ganeti.utils.log_unittest.py \
839 8dc76d54 Guido Trotter
	test/ganeti.utils.mlock_unittest.py \
840 17b97ab3 Michael Hanselmann
	test/ganeti.utils.nodesetup_unittest.py \
841 a4ccecf6 Michael Hanselmann
	test/ganeti.utils.process_unittest.py \
842 79d22269 Michael Hanselmann
	test/ganeti.utils.retry_unittest.py \
843 7fcffe27 Michael Hanselmann
	test/ganeti.utils.text_unittest.py \
844 7831fc5f Michael Hanselmann
	test/ganeti.utils.wrapper_unittest.py \
845 c50645c0 Michael Hanselmann
	test/ganeti.utils.x509_unittest.py \
846 4fd029cf Michael Hanselmann
	test/ganeti.utils_unittest.py \
847 3f991867 Michael Hanselmann
	test/ganeti.workerpool_unittest.py \
848 aefbe369 Michael Hanselmann
	test/cfgupgrade_unittest.py \
849 055f822b Michael Hanselmann
	test/docs_unittest.py \
850 4fd2660d Michael Hanselmann
	test/pycurl_reset_unittest.py \
851 055f822b Michael Hanselmann
	test/tempfile_fork_unittest.py
852 0d20cc42 Bernardo Dal Seno
if HAS_FAKEROOT
853 0d20cc42 Bernardo Dal Seno
python_tests += test/ganeti.utils.io_unittest-runasroot.py
854 0d20cc42 Bernardo Dal Seno
endif
855 e8230860 Michael Hanselmann
856 b91e9518 Iustin Pop
haskell_tests = htools/test
857 b91e9518 Iustin Pop
858 e8c8cf1a Michael Hanselmann
dist_TESTS = \
859 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
860 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
861 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
862 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
863 30f2802f Iustin Pop
	test/cli-test.bash \
864 e8c8cf1a Michael Hanselmann
	$(python_tests)
865 e8c8cf1a Michael Hanselmann
866 e8230860 Michael Hanselmann
nodist_TESTS =
867 d3cd5a3f Iustin Pop
check_SCRIPTS =
868 d3cd5a3f Iustin Pop
869 e5f6768c Iustin Pop
if WANT_HTOOLSTESTS
870 b91e9518 Iustin Pop
nodist_TESTS += $(haskell_tests)
871 04d15e63 Iustin Pop
dist_TESTS += htools/offline-test.sh
872 3096524e Iustin Pop
check_SCRIPTS += htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
873 b91e9518 Iustin Pop
endif
874 e8230860 Michael Hanselmann
875 e8230860 Michael Hanselmann
TESTS = $(dist_TESTS) $(nodist_TESTS)
876 e8230860 Michael Hanselmann
877 27e336af Michael Hanselmann
# Environment for all tests
878 27e336af Michael Hanselmann
PLAIN_TESTS_ENVIRONMENT = \
879 30f2802f Iustin Pop
	PYTHONPATH=. \
880 30f2802f Iustin Pop
	TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
881 30f2802f Iustin Pop
	PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
882 30f2802f Iustin Pop
	$(RUN_IN_TEMPDIR)
883 27e336af Michael Hanselmann
884 27e336af Michael Hanselmann
# Environment for tests run by automake
885 f848ac00 Michael Hanselmann
TESTS_ENVIRONMENT = \
886 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
887 6e06b36c Iustin Pop
888 eed5c5df Michael Hanselmann
all_python_code = \
889 01a3a718 Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
890 cc120286 Bernardo Dal Seno
	$(python_scripts) \
891 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
892 0d2bf835 René Nussbaumer
	$(nodist_pkglib_python_scripts) \
893 e8c8cf1a Michael Hanselmann
	$(python_tests) \
894 01a3a718 Michael Hanselmann
	$(pkgpython_PYTHON) \
895 2d48a3a2 Michael Hanselmann
	$(client_PYTHON) \
896 01a3a718 Michael Hanselmann
	$(hypervisor_PYTHON) \
897 01a3a718 Michael Hanselmann
	$(rapi_PYTHON) \
898 899c4d2c Michael Hanselmann
	$(server_PYTHON) \
899 0d2bf835 René Nussbaumer
	$(pytools_PYTHON) \
900 01a3a718 Michael Hanselmann
	$(http_PYTHON) \
901 01a3a718 Michael Hanselmann
	$(confd_PYTHON) \
902 dc101ecc Michael Hanselmann
	$(masterd_PYTHON) \
903 bb44b1ae Michael Hanselmann
	$(impexpd_PYTHON) \
904 c047a981 Michael Hanselmann
	$(utils_PYTHON) \
905 9f4bb951 Michael Hanselmann
	$(watcher_PYTHON) \
906 a8c68e44 Michael Hanselmann
	$(noinst_PYTHON) \
907 a8c68e44 Michael Hanselmann
	$(qa_scripts)
908 01a3a718 Michael Hanselmann
909 eed5c5df Michael Hanselmann
srclink_files = \
910 6be8e2bf Iustin Pop
	man/footer.rst \
911 7172f605 Michael Hanselmann
	test/check-cert-expired_unittest.bash \
912 571b34f8 Michael Hanselmann
	test/daemon-util_unittest.bash \
913 7172f605 Michael Hanselmann
	test/ganeti-cleaner_unittest.bash \
914 2d76b580 Michael Hanselmann
	test/import-export_unittest.bash \
915 30f2802f Iustin Pop
	test/cli-test.bash \
916 04d15e63 Iustin Pop
	htools/offline-test.sh \
917 d3cd5a3f Iustin Pop
	htools/cli-tests-defs.sh \
918 d6159933 Iustin Pop
	$(all_python_code) \
919 c3f67183 Iustin Pop
	$(HS_LIB_SRCS) $(HS_PROG_SRCS)
920 eed5c5df Michael Hanselmann
921 eed5c5df Michael Hanselmann
check_python_code = \
922 e4e7c7df Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
923 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
924 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
925 95eb4188 Michael Hanselmann
	$(DOCPP) \
926 eed5c5df Michael Hanselmann
	$(all_python_code)
927 eed5c5df Michael Hanselmann
928 e4e7c7df Michael Hanselmann
lint_python_code = \
929 f60d352e Michael Hanselmann
	ganeti \
930 f1763373 Iustin Pop
	ganeti/http/server.py \
931 f60d352e Michael Hanselmann
	$(dist_sbin_SCRIPTS) \
932 cc120286 Bernardo Dal Seno
	$(python_scripts) \
933 2d76b580 Michael Hanselmann
	$(pkglib_python_scripts) \
934 2cc8bdd0 Michael Hanselmann
	$(BUILD_BASH_COMPLETION) \
935 f6cbcc06 Michael Hanselmann
	$(CHECK_IMPORTS) \
936 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
937 95eb4188 Michael Hanselmann
	$(DOCPP) \
938 2cc8bdd0 Michael Hanselmann
	$(PYTHON_BOOTSTRAP)
939 eed5c5df Michael Hanselmann
940 f6cbcc06 Michael Hanselmann
standalone_python_modules = \
941 f6cbcc06 Michael Hanselmann
	lib/rapi/client.py \
942 f6cbcc06 Michael Hanselmann
	tools/ganeti-listrunner
943 f6cbcc06 Michael Hanselmann
944 21bf2e2e Andrea Spadaccini
pep8_python_code = \
945 21bf2e2e Andrea Spadaccini
	ganeti \
946 21bf2e2e Andrea Spadaccini
	ganeti/http/server.py \
947 21bf2e2e Andrea Spadaccini
	$(dist_sbin_SCRIPTS) \
948 cc120286 Bernardo Dal Seno
	$(python_scripts) \
949 21bf2e2e Andrea Spadaccini
	$(pkglib_python_scripts) \
950 21bf2e2e Andrea Spadaccini
	$(BUILD_BASH_COMPLETION) \
951 5d3c30df Michael Hanselmann
	$(CHECK_HEADER) \
952 21bf2e2e Andrea Spadaccini
	$(DOCPP) \
953 21bf2e2e Andrea Spadaccini
	$(PYTHON_BOOTSTRAP) \
954 21bf2e2e Andrea Spadaccini
	qa
955 21bf2e2e Andrea Spadaccini
956 571b34f8 Michael Hanselmann
test/daemon-util_unittest.bash: daemons/daemon-util
957 571b34f8 Michael Hanselmann
958 7172f605 Michael Hanselmann
test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
959 7172f605 Michael Hanselmann
960 26916aad Apollon Oikonomopoulos
tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
961 26916aad Apollon Oikonomopoulos
	sed -f $(REPLACE_VARS_SED) < $< > $@
962 26916aad Apollon Oikonomopoulos
	chmod +x $@
963 26916aad Apollon Oikonomopoulos
964 dbefcc7e Michael Hanselmann
devel/upload: devel/upload.in $(REPLACE_VARS_SED)
965 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
966 e8230860 Michael Hanselmann
	chmod u+x $@
967 e8230860 Michael Hanselmann
968 c964d962 Michael Hanselmann
daemons/%: daemons/%.in $(REPLACE_VARS_SED)
969 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
970 5c566e17 Michael Hanselmann
	chmod +x $@
971 e8230860 Michael Hanselmann
972 c964d962 Michael Hanselmann
doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
973 e8230860 Michael Hanselmann
	sed -f $(REPLACE_VARS_SED) < $< > $@
974 e8230860 Michael Hanselmann
975 c964d962 Michael Hanselmann
doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
976 a2442bf9 Luca Bigliardi
	sed -f $(REPLACE_VARS_SED) < $< > $@
977 a2442bf9 Luca Bigliardi
978 b959138f Michael Hanselmann
doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
979 88a6ca6f Michael Hanselmann
	lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
980 b959138f Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
981 4f3d5b76 Michael Hanselmann
982 f86e82ef Iustin Pop
doc/%.png: doc/%.dot
983 2ab2b9f5 Iustin Pop
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
984 f86e82ef Iustin Pop
	$(DOT) -Tpng -o $@ $<
985 f86e82ef Iustin Pop
986 de8eea3e Iustin Pop
man/footer.man: man/footer.rst
987 de8eea3e Iustin Pop
	@test -n "$(PANDOC)" || \
988 de8eea3e Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
989 de8eea3e Iustin Pop
	$(PANDOC) -f rst -t man -o $@ $<
990 de8eea3e Iustin Pop
991 6be8e2bf Iustin Pop
man/footer.html: man/footer.rst
992 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
993 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
994 6be8e2bf Iustin Pop
	$(PANDOC) -f rst -t html -o $@ $<
995 6be8e2bf Iustin Pop
996 7142485a Iustin Pop
man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
997 7142485a Iustin Pop
	lib/build/shell_example_lexer.py
998 fcdb582d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
999 fcdb582d Michael Hanselmann
1000 5a19bd35 Iustin Pop
man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
1001 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1002 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1003 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1004 9c45babb Iustin Pop
	trap 'echo auto-removing $@; rm $@' EXIT; \
1005 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t man -A man/footer.man $< | \
1006 9c45babb Iustin Pop
	  sed -e 's/\\@/@/g' > $@; \
1007 73d0e218 Iustin Pop
	if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1008 c55cc346 Iustin Pop
	$(CHECK_MAN_DASHES) $@; \
1009 9c45babb Iustin Pop
	trap - EXIT
1010 9c45babb Iustin Pop
1011 2ab2b9f5 Iustin Pop
1012 fcdb582d Michael Hanselmann
man/%.html.in: man/%.gen man/footer.html
1013 6be8e2bf Iustin Pop
	@test -n "$(PANDOC)" || \
1014 6be8e2bf Iustin Pop
	  { echo 'pandoc' not found during configure; exit 1; }
1015 a01dd3c6 Iustin Pop
	set -o pipefail ; \
1016 6be8e2bf Iustin Pop
	$(PANDOC) -s -f rst -t html -A man/footer.html $< | \
1017 6be8e2bf Iustin Pop
	  sed -e 's/\\@/@/g' > $@
1018 6be8e2bf Iustin Pop
1019 5a19bd35 Iustin Pop
man/%.1: man/%.1.in $(REPLACE_VARS_SED)
1020 5a19bd35 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1021 5a19bd35 Iustin Pop
1022 dbefcc7e Michael Hanselmann
man/%.7: man/%.7.in $(REPLACE_VARS_SED)
1023 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1024 e8230860 Michael Hanselmann
1025 dbefcc7e Michael Hanselmann
man/%.8: man/%.8.in $(REPLACE_VARS_SED)
1026 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1027 e8230860 Michael Hanselmann
1028 dbefcc7e Michael Hanselmann
man/%.html: man/%.html.in $(REPLACE_VARS_SED)
1029 2ab2b9f5 Iustin Pop
	sed -f $(REPLACE_VARS_SED) < $< > $@
1030 f29266b4 Iustin Pop
1031 75f76703 Michael Hanselmann
epydoc.conf: epydoc.conf.in Makefile
1032 75f76703 Michael Hanselmann
	sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
1033 f774bd03 Michael Hanselmann
1034 84a12e40 Iustin Pop
vcs-version:
1035 84a12e40 Iustin Pop
	if test -d .git; then \
1036 84a12e40 Iustin Pop
	  git describe > $@; \
1037 84a12e40 Iustin Pop
	elif test ! -f $@ ; then \
1038 84a12e40 Iustin Pop
	  echo "Cannot auto-generate $@ file"; exit 1; \
1039 84a12e40 Iustin Pop
	fi
1040 84a12e40 Iustin Pop
1041 84a12e40 Iustin Pop
.PHONY: regen-vcs-version
1042 84a12e40 Iustin Pop
regen-vcs-version:
1043 e8230860 Michael Hanselmann
	set -e; \
1044 84a12e40 Iustin Pop
	cd $(srcdir); \
1045 84a12e40 Iustin Pop
	if test -d .git; then \
1046 84a12e40 Iustin Pop
	  rm -f vcs-version; \
1047 84a12e40 Iustin Pop
	  $(MAKE) vcs-version; \
1048 84a12e40 Iustin Pop
	fi
1049 84a12e40 Iustin Pop
1050 d6159933 Iustin Pop
htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
1051 d6159933 Iustin Pop
	set -e; \
1052 d6159933 Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1053 d6159933 Iustin Pop
	sed -e "s/%ver%/$$VCSVER/" < $< > $@
1054 d6159933 Iustin Pop
1055 d99d1e36 Iustin Pop
htools/Ganeti/Constants.hs: htools/Ganeti/Constants.hs.in \
1056 ef958f2a Iustin Pop
	lib/constants.py lib/_autoconf.py $(CONVERT_CONSTANTS) \
1057 ef958f2a Iustin Pop
	| lib/_vcsversion.py
1058 11fd5a86 Iustin Pop
	set -e; \
1059 876f6a5e Iustin Pop
	{ cat $< ; PYTHONPATH=. $(CONVERT_CONSTANTS); } > $@
1060 d99d1e36 Iustin Pop
1061 13aeae6a Iustin Pop
lib/_autoconf.py: Makefile | lib/.dir
1062 84a12e40 Iustin Pop
	set -e; \
1063 e8230860 Michael Hanselmann
	{ echo '# This file is automatically generated, do not edit!'; \
1064 e8230860 Michael Hanselmann
	  echo '#'; \
1065 67047322 Iustin Pop
	  echo ''; \
1066 67047322 Iustin Pop
	  echo '"""Build-time configuration for Ganeti.'; \
1067 67047322 Iustin Pop
	  echo '';\
1068 67047322 Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1069 67047322 Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1070 67047322 Iustin Pop
	  echo 'not edit by hand).'; \
1071 67047322 Iustin Pop
	  echo ''; \
1072 67047322 Iustin Pop
	  echo '"""'; \
1073 67047322 Iustin Pop
	  echo ''; \
1074 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1075 0a4e7f24 Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1076 0a4e7f24 Iustin Pop
	  echo '# style warnings' ; \
1077 0a4e7f24 Iustin Pop
	  echo ''; \
1078 e8230860 Michael Hanselmann
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1079 e8230860 Michael Hanselmann
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1080 e8230860 Michael Hanselmann
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1081 e8230860 Michael Hanselmann
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1082 e8230860 Michael Hanselmann
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1083 e8230860 Michael Hanselmann
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1084 e8230860 Michael Hanselmann
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1085 e8230860 Michael Hanselmann
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
1086 553bd93f Vitaly Kuznetsov
	  echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1087 e8230860 Michael Hanselmann
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1088 e8230860 Michael Hanselmann
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1089 2f2dbb4b Jun Futagawa
	  echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1090 e8230860 Michael Hanselmann
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1091 e8230860 Michael Hanselmann
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1092 b8203e1e Iustin Pop
	  echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1093 e8230860 Michael Hanselmann
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1094 cb7c0198 Iustin Pop
	  echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1095 4b97f902 Apollon Oikonomopoulos
	  echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1096 4b97f902 Apollon Oikonomopoulos
	  echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1097 e8230860 Michael Hanselmann
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1098 7e2c5b9e Guido Trotter
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
1099 c4dfb0b6 Andrea Spadaccini
	  echo "IP_PATH = '$(IP_PATH)'"; \
1100 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_PATH = '$(SOCAT)'"; \
1101 fe5b0c42 Michael Hanselmann
	  echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1102 e90739d6 Michael Hanselmann
	  echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1103 bea60381 Michael Hanselmann
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1104 bea60381 Michael Hanselmann
	  echo "TOOLSDIR = '$(toolsdir)'"; \
1105 4f3d5b76 Michael Hanselmann
	  echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1106 f154a7a3 Michael Hanselmann
	  echo "PKGLIBDIR = '$(pkglibdir)'"; \
1107 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1108 8a69b3a8 Andrea Spadaccini
	  echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1109 551b6283 Iustin Pop
	  echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1110 8b72b05c René Nussbaumer
	  echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1111 f12e1736 René Nussbaumer
	  echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1112 8b72b05c René Nussbaumer
	  echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1113 f12e1736 René Nussbaumer
	  echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1114 8b72b05c René Nussbaumer
	  echo "RAPI_USER = '$(RAPI_USER)'"; \
1115 f12e1736 René Nussbaumer
	  echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1116 f12e1736 René Nussbaumer
	  echo "CONFD_USER = '$(CONFD_USER)'"; \
1117 f12e1736 René Nussbaumer
	  echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1118 f12e1736 René Nussbaumer
	  echo "NODED_USER = '$(NODED_USER)'"; \
1119 03881cb0 René Nussbaumer
	  echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1120 3536c792 Iustin Pop
	  echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1121 a002ed79 Agata Murawska
	  echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1122 e5395072 Iustin Pop
	  if [ "$(HTOOLS)" ]; then \
1123 e5395072 Iustin Pop
	    echo "HTOOLS = True"; \
1124 e5395072 Iustin Pop
	  else \
1125 e5395072 Iustin Pop
	    echo "HTOOLS = False"; \
1126 e5395072 Iustin Pop
	  fi; \
1127 cd8b0072 Iustin Pop
	  echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1128 73b0fa69 Iustin Pop
	  echo "PY_CONFD = $(PY_CONFD)"; \
1129 73b0fa69 Iustin Pop
	  echo "HS_CONFD = $(HS_CONFD)"; \
1130 e8230860 Michael Hanselmann
	} > $@
1131 e8230860 Michael Hanselmann
1132 13aeae6a Iustin Pop
lib/_vcsversion.py: Makefile vcs-version | lib/.dir
1133 13aeae6a Iustin Pop
	set -e; \
1134 13aeae6a Iustin Pop
	VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1135 13aeae6a Iustin Pop
	{ echo '# This file is automatically generated, do not edit!'; \
1136 13aeae6a Iustin Pop
	  echo '#'; \
1137 13aeae6a Iustin Pop
	  echo ''; \
1138 13aeae6a Iustin Pop
	  echo '"""Build-time VCS version number for Ganeti.'; \
1139 13aeae6a Iustin Pop
	  echo '';\
1140 13aeae6a Iustin Pop
	  echo 'This file is autogenerated by the build process.'; \
1141 13aeae6a Iustin Pop
	  echo 'For any changes you need to re-run ./configure (and'; \
1142 13aeae6a Iustin Pop
	  echo 'not edit by hand).'; \
1143 13aeae6a Iustin Pop
	  echo ''; \
1144 13aeae6a Iustin Pop
	  echo '"""'; \
1145 13aeae6a Iustin Pop
	  echo ''; \
1146 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0301,C0324'; \
1147 13aeae6a Iustin Pop
	  echo '# because this is autogenerated, we do not want'; \
1148 13aeae6a Iustin Pop
	  echo '# style warnings' ; \
1149 13aeae6a Iustin Pop
	  echo ''; \
1150 13aeae6a Iustin Pop
	  echo "VCS_VERSION = '$$VCSVER'"; \
1151 13aeae6a Iustin Pop
	} > $@
1152 13aeae6a Iustin Pop
1153 96a7481d Michael Hanselmann
lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1154 96a7481d Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1155 d5a2a550 Michael Hanselmann
1156 dbefcc7e Michael Hanselmann
$(REPLACE_VARS_SED): Makefile
1157 e8230860 Michael Hanselmann
	set -e; \
1158 e8230860 Michael Hanselmann
	{ echo 's#@PREFIX@#$(prefix)#g'; \
1159 e8230860 Michael Hanselmann
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
1160 e8230860 Michael Hanselmann
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
1161 7a2ba406 Luca Bigliardi
	  echo 's#@BINDIR@#$(bindir)#g'; \
1162 e8230860 Michael Hanselmann
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
1163 e8230860 Michael Hanselmann
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1164 2f2dbb4b Jun Futagawa
	  echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1165 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1166 e8230860 Michael Hanselmann
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1167 56956bcb Iustin Pop
	  echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1168 56956bcb Iustin Pop
	  echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1169 d3b4cf9f Iustin Pop
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1170 7e1fac25 Michael Hanselmann
	  echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1171 c5159571 Iustin Pop
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
1172 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1173 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
1174 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
1175 0d150c50 René Nussbaumer
	  echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
1176 0d150c50 René Nussbaumer
	  echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1177 0d150c50 René Nussbaumer
	  echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1178 0d150c50 René Nussbaumer
	  echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1179 0d150c50 René Nussbaumer
	  echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1180 46a8da3b René Nussbaumer
	  echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1181 cd8b0072 Iustin Pop
	  echo 's#@CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1182 e8230860 Michael Hanselmann
	} > $@
1183 e8230860 Michael Hanselmann
1184 67313146 Michael Hanselmann
# Using deferred evaluation
1185 899c4d2c Michael Hanselmann
daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1186 9f4bb951 Michael Hanselmann
daemons/ganeti-watcher: MODULE = ganeti.watcher
1187 67313146 Michael Hanselmann
scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1188 0d2bf835 René Nussbaumer
tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1189 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/%,%,$@)
1190 67313146 Michael Hanselmann
1191 c964d962 Michael Hanselmann
$(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
1192 67313146 Michael Hanselmann
	test -n "$(MODULE)" || { echo Missing module; exit 1; }
1193 2d48a3a2 Michael Hanselmann
	set -e; \
1194 d75e738e Michael Hanselmann
	{ echo '#!/usr/bin/python'; \
1195 2d48a3a2 Michael Hanselmann
	  echo '# This file is automatically generated, do not edit!'; \
1196 67313146 Michael Hanselmann
	  echo "# Edit $(MODULE) instead."; \
1197 2d48a3a2 Michael Hanselmann
	  echo; \
1198 67313146 Michael Hanselmann
	  echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1199 2d48a3a2 Michael Hanselmann
	  echo; \
1200 55766d34 Andrea Spadaccini
	  echo '# pylint: disable=C0103'; \
1201 2d48a3a2 Michael Hanselmann
	  echo '# C0103: Invalid name'; \
1202 2d48a3a2 Michael Hanselmann
	  echo; \
1203 2d48a3a2 Michael Hanselmann
	  echo 'import sys'; \
1204 67313146 Michael Hanselmann
	  echo 'import $(MODULE) as main'; \
1205 2d48a3a2 Michael Hanselmann
	  echo; \
1206 2d48a3a2 Michael Hanselmann
	  echo '# Temporarily alias commands until bash completion'; \
1207 2d48a3a2 Michael Hanselmann
	  echo '# generator is changed'; \
1208 67313146 Michael Hanselmann
	  echo 'if hasattr(main, "commands"):'; \
1209 55766d34 Andrea Spadaccini
	  echo '  commands = main.commands # pylint: disable=E1101'; \
1210 3f42b4f6 Michael Hanselmann
	  echo 'if hasattr(main, "aliases"):'; \
1211 55766d34 Andrea Spadaccini
	  echo '  aliases = main.aliases # pylint: disable=E1101'; \
1212 2d48a3a2 Michael Hanselmann
	  echo; \
1213 2d48a3a2 Michael Hanselmann
	  echo 'if __name__ == "__main__":'; \
1214 67313146 Michael Hanselmann
	  echo '  sys.exit(main.Main())'; \
1215 2d48a3a2 Michael Hanselmann
	} > $@
1216 2d48a3a2 Michael Hanselmann
	chmod u+x $@
1217 2d48a3a2 Michael Hanselmann
1218 3096524e Iustin Pop
$(HS_BUILT_TEST_HELPERS): Makefile
1219 3096524e Iustin Pop
	@test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1220 3096524e Iustin Pop
	set -e; \
1221 3096524e Iustin Pop
	{ echo '#!/bin/sh'; \
1222 3096524e Iustin Pop
	  echo '# This file is automatically generated, do not edit!'; \
1223 3096524e Iustin Pop
	  echo "# Edit Makefile.am instead."; \
1224 3096524e Iustin Pop
	  echo; \
1225 3096524e Iustin Pop
	  echo "HTOOLS=$(TESTROLE) exec ./htools/hpc-htools \"\$$@\""; \
1226 3096524e Iustin Pop
	} > $@
1227 3096524e Iustin Pop
	chmod u+x $@
1228 3096524e Iustin Pop
1229 e8230860 Michael Hanselmann
# We need to create symlinks because "make distcheck" will not install Python
1230 e8230860 Michael Hanselmann
# files when building.
1231 c964d962 Michael Hanselmann
stamp-srclinks: Makefile | $(all_dirfiles)
1232 e8230860 Michael Hanselmann
	set -e; \
1233 01a3a718 Michael Hanselmann
	for i in $(srclink_files); do \
1234 e8230860 Michael Hanselmann
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1235 e8230860 Michael Hanselmann
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
1236 e8230860 Michael Hanselmann
		fi; \
1237 e8230860 Michael Hanselmann
	done
1238 dd1dfd9a Michael Hanselmann
	touch $@
1239 97a37b3f Michael Hanselmann
1240 9ff7e35c Michael Hanselmann
.PHONY: ganeti
1241 9ff7e35c Michael Hanselmann
ganeti:
1242 01f3e7b1 Iustin Pop
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1243 9ff7e35c Michael Hanselmann
1244 6b997854 Michael Hanselmann
.PHONY: check-dirs
1245 6b997854 Michael Hanselmann
check-dirs: $(BUILT_SOURCES)
1246 0c1103d6 Iustin Pop
	@set -e; \
1247 6b997854 Michael Hanselmann
	find . -type d \( \( -name . \) -o \( \
1248 6b997854 Michael Hanselmann
		-name .git -o \
1249 6b997854 Michael Hanselmann
		-name autom4te.cache \
1250 6b997854 Michael Hanselmann
		\) -prune -o -print \) | { \
1251 6b997854 Michael Hanselmann
		error=; \
1252 6b997854 Michael Hanselmann
		while read dir; do \
1253 6b997854 Michael Hanselmann
			case "$$dir" in \
1254 6b997854 Michael Hanselmann
				$(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1255 6b997854 Michael Hanselmann
				*) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1256 6b997854 Michael Hanselmann
			esac; \
1257 6b997854 Michael Hanselmann
		done; \
1258 6b997854 Michael Hanselmann
		for dir in $(DIRS); do \
1259 6b997854 Michael Hanselmann
			if ! test -d "$$dir"; then \
1260 6b997854 Michael Hanselmann
				echo "Directory $$dir listed in DIRS does not exist" >&2; \
1261 6b997854 Michael Hanselmann
				error=1; \
1262 6b997854 Michael Hanselmann
			fi \
1263 6b997854 Michael Hanselmann
		done; \
1264 6b997854 Michael Hanselmann
		if test -n "$$error"; then exit 1; else exit 0; fi; \
1265 6b997854 Michael Hanselmann
	}
1266 6b997854 Michael Hanselmann
1267 f6cbcc06 Michael Hanselmann
.PHONY: check-local
1268 f6cbcc06 Michael Hanselmann
check-local: check-dirs $(BUILT_SOURCES)
1269 eed5c5df Michael Hanselmann
	$(CHECK_PYTHON_CODE) $(check_python_code)
1270 5d3c30df Michael Hanselmann
	PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1271 35576615 Michael Hanselmann
	$(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1272 7385c51d Michael Hanselmann
	$(CHECK_NEWS) < $(top_srcdir)/NEWS
1273 83ea5145 Michael Hanselmann
	PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1274 9488fd1d Michael Hanselmann
	expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1275 154d7ba5 Michael Hanselmann
	if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1276 9488fd1d Michael Hanselmann
		echo "Incorrect version in README, expected $$expver"; \
1277 9488fd1d Michael Hanselmann
		exit 1; \
1278 7ecb3d0e Michael Hanselmann
	fi; \
1279 d5114fa1 Michael Hanselmann
	for file in doc/iallocator.rst doc/hooks.rst; do \
1280 d5114fa1 Michael Hanselmann
		if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1281 9822b1dd Iustin Pop
			"Documents Ganeti version $$expver"; then \
1282 d5114fa1 Michael Hanselmann
			echo "Incorrect version in $$file, expected $$expver"; \
1283 d5114fa1 Michael Hanselmann
			exit 1; \
1284 d5114fa1 Michael Hanselmann
		fi; \
1285 d5114fa1 Michael Hanselmann
	done
1286 eed5c5df Michael Hanselmann
1287 49e11c49 Iustin Pop
.PHONY: hs-check
1288 3096524e Iustin Pop
hs-check: htools/test htools/hpc-htools $(HS_BUILT_TEST_HELPERS)
1289 49e11c49 Iustin Pop
	@rm -f test.tix
1290 49e11c49 Iustin Pop
	./htools/test
1291 896b2850 Iustin Pop
	HBINARY="./htools/hpc-htools" ./htools/offline-test.sh
1292 49e11c49 Iustin Pop
1293 08366664 Michael Hanselmann
# E111: indentation is not a multiple of four
1294 08366664 Michael Hanselmann
# E261: at least two spaces before inline comment
1295 08366664 Michael Hanselmann
# E501: line too long (80 characters)
1296 08366664 Michael Hanselmann
PEP8_IGNORE = E111,E261,E501
1297 08366664 Michael Hanselmann
1298 08366664 Michael Hanselmann
# For excluding pep8 expects filenames only, not whole paths
1299 08366664 Michael Hanselmann
PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1300 08366664 Michael Hanselmann
1301 e0098923 Iustin Pop
.PHONY: lint
1302 c964d962 Michael Hanselmann
lint: $(BUILT_SOURCES)
1303 6d7cc5ff Michael Hanselmann
	@test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1304 08366664 Michael Hanselmann
	if test -z "$(PEP8)"; then \
1305 08366664 Michael Hanselmann
		echo '"pep8" not found during configure' >&2; \
1306 08366664 Michael Hanselmann
	else \
1307 08366664 Michael Hanselmann
		$(PEP8) --repeat --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1308 21bf2e2e Andrea Spadaccini
			$(pep8_python_code); \
1309 08366664 Michael Hanselmann
	fi
1310 6d7cc5ff Michael Hanselmann
	$(PYLINT) $(LINT_OPTS) $(lint_python_code)
1311 3582eef6 Iustin Pop
	cd $(top_srcdir)/qa && \
1312 3582eef6 Iustin Pop
	  PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1313 3582eef6 Iustin Pop
	  --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1314 e0098923 Iustin Pop
1315 191ff68c Iustin Pop
.PHONY: hlint
1316 5a1e31b4 Iustin Pop
hlint: $(HS_BUILT_SRCS) htools/lint-hints.hs
1317 191ff68c Iustin Pop
	if tty -s; then C="-c"; else C=""; fi; \
1318 3603605a Iustin Pop
	hlint --report=doc/hs-lint.html --cross $$C \
1319 3603605a Iustin Pop
	  --ignore "Use first" \
1320 3603605a Iustin Pop
	  --ignore "Use comparing" \
1321 3603605a Iustin Pop
	  --ignore "Use on" \
1322 3603605a Iustin Pop
	  --ignore "Use Control.Exception.catch" \
1323 3603605a Iustin Pop
	  --ignore "Reduce duplication" \
1324 5a1e31b4 Iustin Pop
	  --hint htools/lint-hints \
1325 3603605a Iustin Pop
	  $(filter-out htools/Ganeti/THH.hs,$(HS_LIB_SRCS))
1326 191ff68c Iustin Pop
1327 84a12e40 Iustin Pop
# a dist hook rule for updating the vcs-version file; this is
1328 84a12e40 Iustin Pop
# hardcoded due to where it needs to build the file...
1329 84a12e40 Iustin Pop
dist-hook:
1330 84a12e40 Iustin Pop
	$(MAKE) regen-vcs-version && \
1331 84a12e40 Iustin Pop
	rm -f $(top_distdir)/vcs-version && \
1332 84a12e40 Iustin Pop
	cp -p $(srcdir)/vcs-version $(top_distdir)
1333 84a12e40 Iustin Pop
1334 84a12e40 Iustin Pop
# a distcheck hook rule for catching revision control directories
1335 b6f2e47f Iustin Pop
distcheck-hook:
1336 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1337 c6aa0c42 Michael Hanselmann
		echo "Found revision control files in final archive." 1>&2; \
1338 c6aa0c42 Michael Hanselmann
		exit 1; \
1339 c6aa0c42 Michael Hanselmann
	fi
1340 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*.py[co]' | grep .; then \
1341 c6aa0c42 Michael Hanselmann
		echo "Found Python byte code in final archive." 1>&2; \
1342 c6aa0c42 Michael Hanselmann
		exit 1; \
1343 c6aa0c42 Michael Hanselmann
	fi
1344 c6aa0c42 Michael Hanselmann
	if find $(top_distdir) -name '*~' | grep .; then \
1345 c6aa0c42 Michael Hanselmann
		echo "Found backup files in final archive." 1>&2; \
1346 b6f2e47f Iustin Pop
		exit 1; \
1347 b6f2e47f Iustin Pop
	fi
1348 bf0b21da Michael Hanselmann
# Empty files or directories should not be distributed. They can cause
1349 bf0b21da Michael Hanselmann
# unnecessary warnings for packagers. Directories used by automake during
1350 bf0b21da Michael Hanselmann
# distcheck must be excluded.
1351 bf0b21da Michael Hanselmann
	if find $(top_distdir) -empty -and -not \( \
1352 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_build -or \
1353 bf0b21da Michael Hanselmann
			-path $(top_distdir)/_inst \) | grep .; then \
1354 bf0b21da Michael Hanselmann
		echo "Found empty files or directories in final archive." 1>&2; \
1355 bf0b21da Michael Hanselmann
		exit 1; \
1356 bf0b21da Michael Hanselmann
	fi
1357 c7b86f6c Michael Hanselmann
	if test -n "$(BUILD_RELEASE)" && \
1358 c7b86f6c Michael Hanselmann
	   grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1359 c7b86f6c Michael Hanselmann
		echo "Found unreleased version in NEWS." >&2; \
1360 c7b86f6c Michael Hanselmann
		exit 1; \
1361 c7b86f6c Michael Hanselmann
	fi
1362 c7b86f6c Michael Hanselmann
1363 c7b86f6c Michael Hanselmann
# When building a release, stricter checks should be used
1364 e627fe09 Michael Hanselmann
distcheck-release dist-release: export BUILD_RELEASE = 1
1365 c7b86f6c Michael Hanselmann
distcheck-release: distcheck
1366 b6f2e47f Iustin Pop
1367 e627fe09 Michael Hanselmann
dist-release: dist
1368 e627fe09 Michael Hanselmann
	set -e; \
1369 e627fe09 Michael Hanselmann
	for i in $(DIST_ARCHIVES); do \
1370 e627fe09 Michael Hanselmann
		echo -n "Checking $$i ... "; \
1371 e627fe09 Michael Hanselmann
		autotools/check-tar < $$i; \
1372 e627fe09 Michael Hanselmann
		echo OK; \
1373 e627fe09 Michael Hanselmann
	done
1374 e627fe09 Michael Hanselmann
1375 8925faaa Iustin Pop
install-exec-local:
1376 0d93b082 Michael Hanselmann
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1377 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
1378 2fa9f1dd Michael Hanselmann
	  "$(DESTDIR)${localstatedir}/run/ganeti"
1379 e8230860 Michael Hanselmann
1380 c964d962 Michael Hanselmann
# To avoid conflicts between directory names and other targets, a file inside
1381 c964d962 Michael Hanselmann
# the directory is used to ensure its existence.
1382 c964d962 Michael Hanselmann
%.dir:
1383 c964d962 Michael Hanselmann
	@mkdir_p@ $* && touch $@
1384 e8230860 Michael Hanselmann
1385 d128fdb6 Iustin Pop
.PHONY: apidoc
1386 a38bfce5 Iustin Pop
if WANT_HTOOLSAPIDOC
1387 a38bfce5 Iustin Pop
apidoc: py-apidoc hs-apidoc
1388 a38bfce5 Iustin Pop
else
1389 a38bfce5 Iustin Pop
apidoc: py-apidoc
1390 a38bfce5 Iustin Pop
endif
1391 a38bfce5 Iustin Pop
1392 a38bfce5 Iustin Pop
.PHONY: py-apidoc
1393 a38bfce5 Iustin Pop
py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1394 b959138f Michael Hanselmann
	$(RUN_IN_TEMPDIR) epydoc -v \
1395 b959138f Michael Hanselmann
		--conf $(CURDIR)/epydoc.conf \
1396 22c5390d Iustin Pop
		--output $(CURDIR)/$(APIDOC_PY_DIR)
1397 a38bfce5 Iustin Pop
1398 a38bfce5 Iustin Pop
.PHONY: hs-apidoc
1399 c3f67183 Iustin Pop
hs-apidoc: $(HS_BUILT_SRCS)
1400 a38bfce5 Iustin Pop
	@test -n "$(HSCOLOUR)" || \
1401 a38bfce5 Iustin Pop
	    { echo 'HsColour' not found during configure; exit 1; }
1402 a38bfce5 Iustin Pop
	@test -n "$(HADDOCK)" || \
1403 a38bfce5 Iustin Pop
	    { echo 'haddock' not found during configure; exit 1; }
1404 22c5390d Iustin Pop
	rm -rf $(APIDOC_HS_DIR)/*
1405 458a286a Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools/Program
1406 358a0a8f Iustin Pop
	@mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/Confd
1407 22c5390d Iustin Pop
	$(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1408 82888134 Michael Hanselmann
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1409 358a0a8f Iustin Pop
	$(LN_S) ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/Confd/hscolour.css
1410 a38bfce5 Iustin Pop
	set -e ; \
1411 a38bfce5 Iustin Pop
	cd htools; \
1412 c478f837 Iustin Pop
	if [ "$(HTOOLS_NOCURL)" ]; \
1413 c478f837 Iustin Pop
	then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1414 c478f837 Iustin Pop
	else OPTGHC=""; \
1415 c478f837 Iustin Pop
	fi; \
1416 1adec4be Iustin Pop
	if [ "$(HTOOLS_PARALLEL3)" ]; \
1417 1adec4be Iustin Pop
	then OPTGHC="$$OPTGHC --optghc=$(HTOOLS_PARALLEL3)"; \
1418 1adec4be Iustin Pop
	fi; \
1419 606e71d3 Iustin Pop
	RELSRCS="$(HS_LIB_SRCS:htools/%=%)  $(HS_BUILT_SRCS:htools/%=%)"; \
1420 a38bfce5 Iustin Pop
	for file in $$RELSRCS; do \
1421 a38bfce5 Iustin Pop
		hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1422 22c5390d Iustin Pop
		$(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1423 a38bfce5 Iustin Pop
	done ; \
1424 22c5390d Iustin Pop
	$(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1425 a38bfce5 Iustin Pop
		-t ganeti-htools -p haddock-prologue \
1426 a38bfce5 Iustin Pop
		--source-module="%{MODULE/.//}.html" \
1427 a38bfce5 Iustin Pop
		--source-entity="%{MODULE/.//}.html#%{NAME}" \
1428 c478f837 Iustin Pop
		$$OPTGHC \
1429 c3f67183 Iustin Pop
		$(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1430 d128fdb6 Iustin Pop
1431 13e720f1 Iustin Pop
.PHONY: TAGS
1432 eb732fb5 Michael Hanselmann
TAGS: $(BUILT_SOURCES)
1433 13e720f1 Iustin Pop
	rm -f TAGS
1434 74fa8200 Iustin Pop
	find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1435 74fa8200 Iustin Pop
	  -path './daemons/ganeti-*' -o -path './tools/*' -o \
1436 74fa8200 Iustin Pop
	  -path './qa/*.py' | \
1437 3bb5c580 Iustin Pop
	  etags -l python -
1438 13e720f1 Iustin Pop
1439 27e336af Michael Hanselmann
.PHONY: coverage
1440 b91e9518 Iustin Pop
if WANT_HTOOLS
1441 b91e9518 Iustin Pop
coverage: py-coverage hs-coverage
1442 b91e9518 Iustin Pop
else
1443 b91e9518 Iustin Pop
coverage: py-coverage
1444 b91e9518 Iustin Pop
endif
1445 b91e9518 Iustin Pop
1446 b91e9518 Iustin Pop
.PHONY: py-coverage
1447 b91e9518 Iustin Pop
py-coverage: $(BUILT_SOURCES) $(python_tests)
1448 27e336af Michael Hanselmann
	set -e; \
1449 22c5390d Iustin Pop
	COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1450 22c5390d Iustin Pop
	TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1451 22c5390d Iustin Pop
	HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1452 e8c8cf1a Michael Hanselmann
	$(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1453 e8c8cf1a Michael Hanselmann
	$(python_tests)
1454 27e336af Michael Hanselmann
1455 b91e9518 Iustin Pop
.PHONY: hs-coverage
1456 896b2850 Iustin Pop
hs-coverage: $(haskell_tests) htools/hpc-htools
1457 25cdf177 Iustin Pop
	rm -f *.tix && $(MAKE) hs-check
1458 48f12e73 Iustin Pop
	@mkdir_p@ $(COVERAGE_HS_DIR)
1459 896b2850 Iustin Pop
	hpc combine $(HPCEXCL) test.tix hpc-htools.tix > coverage-htools.tix
1460 896b2850 Iustin Pop
	hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-htools.tix
1461 896b2850 Iustin Pop
	hpc report coverage-htools.tix
1462 82888134 Michael Hanselmann
	$(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1463 b91e9518 Iustin Pop
1464 ec8379bd Iustin Pop
# Special "kind-of-QA" target for htools, needs special setup (all
1465 ec8379bd Iustin Pop
# tools compiled with -fhpc)
1466 ec8379bd Iustin Pop
.PHONY: live-test
1467 ec8379bd Iustin Pop
live-test: all
1468 ec8379bd Iustin Pop
	set -e ; \
1469 ec8379bd Iustin Pop
	cd htools; \
1470 82888134 Michael Hanselmann
	rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1471 ec8379bd Iustin Pop
	rm -f *.tix *.mix; \
1472 ec8379bd Iustin Pop
	./live-test.sh; \
1473 c3f67183 Iustin Pop
	hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1474 ec8379bd Iustin Pop
	  --output=live-test.tix ; \
1475 22c5390d Iustin Pop
	@mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1476 22c5390d Iustin Pop
	hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1477 ec8379bd Iustin Pop
		--srcdir=.. $(HPCEXCL) ; \
1478 ec8379bd Iustin Pop
	hpc report --srcdir=.. live-test $(HPCEXCL)
1479 b91e9518 Iustin Pop
1480 b341b9ca Guido Trotter
commit-check: distcheck lint apidoc
1481 b341b9ca Guido Trotter
1482 3baa809c Michael Hanselmann
-include ./Makefile.local
1483 3baa809c Michael Hanselmann
1484 e8230860 Michael Hanselmann
# vim: set noet :